// See LICENSE for license details.

package example.test

import chisel3.iotesters.{ChiselFlatSpec, Driver, PeekPokeTester}
import example.xor_acc

class xor_accUnitTester(c: xor_acc) extends PeekPokeTester(c) {
  
  private val xor_acc = c
  for (t <- 0 until 100) {
    val data_0 = rnd.nextInt(256) 
    val data_1 = rnd.nextInt(256)
    val data_2 = rnd.nextInt(256)
    val data_3 = rnd.nextInt(256)
    val data_4 = rnd.nextInt(256)
    val data_5 = rnd.nextInt(256)
    val data_6 = rnd.nextInt(256)
    val data_7 = rnd.nextInt(256)
    val key_0 = rnd.nextInt(256) 
    val key_1 = rnd.nextInt(256)
    val key_2 = rnd.nextInt(256)
    val key_3 = rnd.nextInt(256)
    val key_4 = rnd.nextInt(256)
    val key_5 = rnd.nextInt(256)
    val key_6 = rnd.nextInt(256)
    val key_7 = rnd.nextInt(256)

    val xor_0 = data_0 ^ key_0
    val xor_1 = data_1 ^ key_1
    val xor_2 = data_2 ^ key_2
    val xor_3 = data_3 ^ key_3
    val xor_4 = data_4 ^ key_4
    val xor_5 = data_5 ^ key_5
    val xor_6 = data_6 ^ key_6
    val xor_7 = data_7 ^ key_7

    poke(xor_acc.io.data_0, data_0)
    poke(xor_acc.io.data_1, data_1)
    poke(xor_acc.io.data_2, data_2)
    poke(xor_acc.io.data_3, data_3)
    poke(xor_acc.io.data_4, data_4)
    poke(xor_acc.io.data_5, data_5)
    poke(xor_acc.io.data_6, data_6)
    poke(xor_acc.io.data_7, data_7)

    poke(xor_acc.io.key_0, key_0)
    poke(xor_acc.io.key_1, key_1)
    poke(xor_acc.io.key_2, key_2)
    poke(xor_acc.io.key_3, key_3)
    poke(xor_acc.io.key_4, key_4)
    poke(xor_acc.io.key_5, key_5)
    poke(xor_acc.io.key_6, key_6)
    poke(xor_acc.io.key_7, key_7)

    step(1)
    
    expect(xor_acc.io.xor_0, xor_0)
    expect(xor_acc.io.xor_1, xor_1)
    expect(xor_acc.io.xor_2, xor_2)
    expect(xor_acc.io.xor_3, xor_3)
    expect(xor_acc.io.xor_4, xor_4)
    expect(xor_acc.io.xor_5, xor_5)
    expect(xor_acc.io.xor_6, xor_6)
    expect(xor_acc.io.xor_7, xor_7)
  }
}

class XOR_ACCTester extends ChiselFlatSpec {
  private val backendNames = Array[String]("verilator")
  for ( backendName <- backendNames ) {
    "xor_acc" should s"calculate proper greatest common denominator (with $backendName)" in {
      Driver(() => new xor_acc, backendName) {
        c => new xor_accUnitTester(c)
      } should be (true)
    }
  }
}
