#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "sync.h"
#include "memory_map.h"
#include "golden.h"


typedef union word{
    unsigned int uint;
    unsigned char uc[4];
} word;

char BASE64CODE[64] = {
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
	'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
	'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
	'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
	'w', 'x', 'y', 'z', '0', '1', '2', '3',
	'4', '5', '6', '7', '8', '9', '+', '/'
};

void base64en(char *srcStr, char *desStr)
{
	unsigned char srcCode[3];
	unsigned int i, j, len;

	len = strlen(srcStr) / 3;
	for (i = 0; i < len; i++)
	{
		srcCode[0] = srcStr[i * 3 + 0];
		srcCode[1] = srcStr[i * 3 + 1];
		srcCode[2] = srcStr[i * 3 + 2];

		desStr[i * 4 + 0] = BASE64CODE[srcCode[0] >> 2];
		desStr[i * 4 + 1] = BASE64CODE[((srcCode[0] & 0x03) << 4) + (srcCode[1] >> 4)];
		desStr[i * 4 + 2] = BASE64CODE[((srcCode[1] & 0x0f) << 2) + (srcCode[2] >> 6)];
		desStr[i * 4 + 3] = BASE64CODE[srcCode[2] & 0x3f];
	}

	i = len;
	j = strlen(srcStr) - len * 3;
	if (j > 0)
	{
		srcCode[0] = srcStr[i * 3 + 0];
		srcCode[1] = (j > 1) ? srcStr[i * 3 + 1] : '\0';
		srcCode[2] = '\0';

		desStr[i * 4 + 0] = BASE64CODE[srcCode[0] >> 2];
		desStr[i * 4 + 1] = BASE64CODE[((srcCode[0] & 0x03) << 4) + (srcCode[1] >> 4)];
		desStr[i * 4 + 2] = (srcCode[1] == '\0') ? '=' : BASE64CODE[(srcCode[1] & 0x0f) << 2];
		desStr[i * 4 + 3] = '=';

		i++;
	}

	desStr[i * 4] = '\0';
}
/*
char soft_xor(char input, char key)
{
	return input ^ key;
}
*/
void info_printf(int cid, int part_size, char* tmp, char* origin_en, char* xor_en) {
	printf("cid: %d\n", cid);
	printf("%s => %s\n", tmp, origin_en);
	printf("%d => %d\n", strlen(tmp), strlen(origin_en));
	int i;
	printf("lenght of xor_en: %d\n", part_size);
	for(i=0; i<part_size;i++) {
		printf("%d ", xor_en[i]);
	}
	printf("\n");
}


unsigned char global_ans[1000] = { 0 };
Mutex mutex;

void thread_entry(int cid, int nc) {
	// int main(int argc, char **argv)
	unsigned char src[1000] = {0};
	unsigned char en[1000] = {0}, de[1000] = {0};
	unsigned char tmp[500] = {0};
	unsigned char chrkey[100] = {0};
	int intdatalen, intkeylen;
	int i, j;
	int a = 0;
	strcpy(chrkey, "jasonkey");

	strcpy(src, "Man is distinguished, not  by his reason, but by this singular passion from other animals, which is a lust of the mind, that by a perseverance of delight in the continued and indefatigable generation of knowledge, exceeds the short vehemence of any carnal pleasure");

	strncpy(tmp, src+cid*strlen(src)/4, strlen(src)/4);
	base64en(tmp, en);
	strcpy(de, en);
	// printf("%s => %s\n", src, en);

	intdatalen = strlen(en);
	intkeylen = strlen(chrkey);
	int xor_size = strlen(src)/3;
	int xx, yy=0;
	word data, key, ans;
	for(xx=0; xx<intdatalen; xx = xx+8) {
		data.uc[0] = en[xx+0];
		data.uc[1] = en[xx+1];
		data.uc[2] = en[xx+2];
		data.uc[3] = en[xx+3];
        REG_U32( DATA_ADDR ) = data.uint;
		data.uc[0] = en[xx+4];
		data.uc[1] = en[xx+5];
		data.uc[2] = en[xx+6];
		data.uc[3] = en[xx+7];
        REG_U32( DATA_ADDR ) = data.uint;
		key.uc[0] = chrkey[0];
		key.uc[1] = chrkey[1];
		key.uc[2] = chrkey[2];
		key.uc[3] = chrkey[3];
        REG_U32( DATA_ADDR ) = key.uint;
		key.uc[0] = chrkey[4];
		key.uc[1] = chrkey[5];
		key.uc[2] = chrkey[6];
		key.uc[3] = chrkey[7];
        REG_U32( DATA_ADDR ) = key.uint;
		
        ans.uint = REG_U32( ANS_ADDR );
		en[xx+0] = ans.uc[0];
		en[xx+1] = ans.uc[1];
		en[xx+2] = ans.uc[2];
		en[xx+3] = ans.uc[3];
        ans.uint = REG_U32( ANS_ADDR );
		en[xx+4] = ans.uc[0];
		en[xx+5] = ans.uc[1];
		en[xx+6] = ans.uc[2];
		en[xx+7] = ans.uc[3];
		//en[xx] = soft_xor(en[xx], chrkey[yy++]);
		//if(yy == intkeylen) yy = 0;
	}

	barrier(nc);


	mutex_lock(&mutex);
	int cnt, cnt_encode = 0;
	for(cnt=cid*strlen(src)/3; cnt<cid*strlen(src)/3+strlen(src)/3; cnt++) {
		global_ans[cnt] = en[cnt_encode++];
	}
	mutex_unlock(&mutex);

	barrier(nc);

	if (cid == 0) {
		/* for golden
		int i;
		printf("unsigned char golden[1000] = {");
		for(i=0; i<(strlen(src)*4)/3; i++) {
			// if(i%88 == 0) printf("\n");
			printf("%d, ", global_ans[i]);
		}
		printf("};");
		printf("\n");
		*/
		int i, error_cnt = 0;
		for(i = 0; i < (strlen(src)*4)/3; i++) {
			if(global_ans[i] != golden[i]) 
				error_cnt++;
			//printf("global_ans: %3d, golden: %3d\n", global_ans[i], golden[i]);
		}
		if(error_cnt > 0) printf("Fail\n");
		else printf("Success\n");
	}
	barrier(nc);

/*

	if (cid == 0) {
		printf("strlen of src: %d\n", strlen(src));
		info_printf(cid, xor_size, tmp, de, en);
	}
	barrier(nc);
	if (cid == 1) {
		info_printf(cid, xor_size, tmp, de, en);
	}
	barrier(nc);
	if (cid == 2) {
		info_printf(cid, xor_size, tmp, de, en);
	}
	barrier(nc);
	if (cid == 3) {
		info_printf(cid, xor_size, tmp, de, en);
	}
	barrier(nc);
*/
	// before the exit, we need to synchronous four threads.
	exit(0);
}



