#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "sync.h"
#include <math.h>
#include "image_arr.h"
//#include "util.h"

#define MASK_N 2
#define MASK_X 3
#define MASK_Y 3
#define WHITE  255
#define BLACK  0
#define HEIGHT 20
#define WIDTH 20
#define BIT_PER_PIXEL 24

// double pi_over_4 = 0;
int error_cnt = 0;
Mutex mutex;

// int main() {
void thread_entry(int cid, int nc) {
	unsigned int  x, y, i, v, u;             // for loop counter
	unsigned char R, G, B;         // color of R, G, B
	double val[MASK_N] = {0.0};
	int adjustX, adjustY, xBound, yBound;
	double total;
	unsigned int width = 20, height = 20;      // image width, image height
	unsigned int byte_per_pixel = 3;     // byte per pixel
	double threshold = 90.0;
	// sobel mask
	int mask[MASK_N][MASK_X][MASK_Y] = {
		{   { -1, -2, -1},
			{0 , 0, 0},
			{1 , 2, 1}
		},

		{   { -1, 0, 1},
			{ -2, 0, 2},
			{ -1, 0, 1}
		}
	};

	// binary encode table (mod2)
    // cid binary_encode_x binary_encode_y
	//   0               0               0
    //   1               0               1
    //   2               1               0
    //   3               1               1
	unsigned int binary_encode_x = cid/2, binary_encode_y = cid%2;
	unsigned int x_offset = 10, y_offset = 10;
	for (y = binary_encode_y * y_offset; y != binary_encode_y * y_offset + y_offset; ++y) {
		for (x = binary_encode_x * x_offset; x != binary_encode_x * x_offset + x_offset; ++x) {
			for (i = 0; i != MASK_N; ++i) {
				adjustX = (MASK_X % 2) ? 1 : 0;
				adjustY = (MASK_Y % 2) ? 1 : 0;
				xBound = MASK_X / 2;
				yBound = MASK_Y / 2;

				val[i] = 0.0;
				for (v = -yBound; v != yBound + adjustY; ++v) {
					for (u = -xBound; u != xBound + adjustX; ++u) {
						if (x + u >= 0 && x + u < width && y + v >= 0 && y + v < height) {
							R = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 2);
							G = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 1);
							B = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 0);
							// val[i] += color_to_int(R, G, B) * mask[i][u + xBound][v + yBound];
							val[i] += ((int)R+(int)G+(int)B)/3 * mask[i][u + xBound][v + yBound];
						}
					}
				}
			}

			total = 0.0;
			for (i = 0; i != MASK_N; ++i) {
				total += val[i] * val[i];
			}

			// total = sqrt(total);
			if (total <= 1)
				continue;
			else {
				double l = 1, r = total, sol, mid;
				while (l <= r) {
					mid = l + (r - l) / 2;
					if (mid <= total / mid) {
						l = mid + 1;
						sol = mid;
					}
					else
						r = mid - 1;
				}
				total = sol;
			}
			// printf("x = %d, y = %d.\n", x, y);
			if (total - threshold >= 0) {
				// black
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 2) != BLACK) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 1) != BLACK) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 0) != BLACK) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}

				//*(image_t_array + byte_per_pixel * (width * y + x) + 2) = BLACK;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 1) = BLACK;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 0) = BLACK;
			} else {
				// white

				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 2) != WHITE) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 1) != WHITE) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 0) != WHITE) {
					// mutex_lock(&mutex);
					error_cnt++;
					// mutex_unlock(&mutex);
				}

				//*(image_t_array + byte_per_pixel * (width * y + x) + 2) = WHITE;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 1) = WHITE;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 0) = WHITE;
			}
			barrier(nc);
		}
	}
	if (cid == 0) {
		// end = read_cycles();
		printf("error_cnt: %d\n", error_cnt);
		// printf("Took %ld cycles and end %ld start %ld\n",end - start, end, start);
		if(error_cnt == 0) {
			printf("Success!!\n");
		} else {
			printf("Failed!!\n");
		} 
	}
	barrier(nc);
	// before the exit, we need to synchronous four threads.
    exit(0);
}


