# Report

## Problem requirements
- Convert "soble.c" C codes into SysyemC processes.
- Use SystemC datatype as possible for Calculation process.
- Process a quarter of the image at a time.
- Implement handshaking between processes.

## Architecture
![architecture](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw1_thread/architecture.PNG)

## Implementation
- In the my_sobel.h, we declare the My_sobel class, some sc_event to handshaking, and register three functions, "read_bmp()", "sobel()"and "write_bmp()" as SystemC processes.
- In the my_sobel.cpp, the function "read_bmp()" read data from "lena.bmp", and use sc_event to notify process "sobel()". The function "sobel()" calculate a quarter of the image at a time with offset by shifting half width of the image or half height of the image or shift both. After the calcalation, use sc_event to notify process "write_bmp()". At the beginning of the "write_bmp()", a if function will check the left number of the quarter to calculate, if there is, use sc_event to notify process "sobel()"to calculate other quarter of the image until all quarter has been calculated. At last, use sc_event to notify process "write_bmp()" to write the result image.
- In the main.cpp, we define the main function where a My_sobel is instantiated.

## Additional feature
- Compared with the previous implementation of hw01, here use SC_THREAD to register function.
- Also in my_sobel.cpp, implement function by using methods such as while(true) and notify(). The way is different from SC_METHOD.

## Compile and Run
- Edit the "Makefile" to perform a sequence of commands to build an application.
- Type "make" in the command line to generate executable file.
- Make sure the file "lena.bmp" is present in the current folder.
- Type "./sobel.exe" in the command line to generate output picture.

## Results
![pic](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw1_thread/lena_sobel.bmp)

## Discussions and conclusions
- Learn to build a SystemC process.
- Learn to use sc_event to trigger other process.
