# Report

## Problem requirements
- Implement a fixed-point sobel algorithm with SystemC datatypes and Modules.
- Modules are connected with SystemC channels and ports.
- Two versions: one with FIFO channel and the other with signal channel.
- There will be a top module making connections between sub-modules.
- Implement handshaking between Input and Calculation modules, and also Calculation and Output modules.

## Architecture
![architecture](fifo_architecture.PNG)

## Implementation
- In top.h, declare some sc_fifo, sc_event, and define the ports of the submodule to connect to the declared sc_fifo.
- In three header file, read_bmp.h, sobel.h, write_bmp.h, declare the ports of the submodule. For example, if it is the output of the port, which is declared as sc_fifo_out.
- In read_bmp.cpp, when some data are ready to pass to another submodule, use write() to pass the data to the corresponding port declared in the read_bmp.h.
- In sobel.cpp, use read() to get the data which are passed from read_bmp module.

## Compile, run and display
- Edit the "Makefile" to perform a sequence of commands to build an application.
- Type "make" in the command line to generate executable file.
- Make sure the file "lena.bmp" is present in the current folder.
- Type "./sobel.exe" in the command line to generate output picture.
- Type "display lena_sobel.bmp &" in the command line to show output picture.

## Result
![result](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw2_fifo/lena_sobel.bmp)

## Discussions and conclusions
- Learn to declare sc_fifo, submodule ports.
- Learn to use sc_fifo to connect submodule.
- Learn to write the data through the ports to sc_fifo.
- Learn to read data through the ports from sc_fifo.
