#ifndef _READ_BMP_H_
#define _READ_BMP_H_
#include <systemc>
using namespace sc_core;

SC_MODULE(Read_bmp) {
public:
	sc_fifo_out<unsigned int>   o_width;
	sc_fifo_out<unsigned int>   o_height;
	sc_fifo_out<unsigned int>   o_rgb_raw_data_offset;
	sc_fifo_out<unsigned char>  o_bit_per_pixel;
	sc_fifo_out<unsigned short> o_byte_per_pixel;
	sc_fifo_out<uint8_t*>       o_image_s;
	sc_fifo_out<uint8_t*>       o_image_t;

	sc_event *o_readDone_event;

	SC_CTOR(Read_bmp) {
		SC_THREAD(read_bmp);
	}

private:
	unsigned int   width;
	unsigned int   height;
	unsigned int   rgb_raw_data_offset;
	unsigned char  bit_per_pixel;
	unsigned short byte_per_pixel;
	unsigned char  *image_s;     // source image array
	unsigned char  *image_t;     // target image array
	void read_bmp();
};

#endif