#ifndef _SOBEL_H_
#define _SOBEL_H_
#include <systemc>
using namespace sc_core;

SC_MODULE(Sobel) {
public:
	sc_fifo_in<unsigned int>    i_width;
	sc_fifo_in<unsigned int>    i_height;
	sc_fifo_in<unsigned int>    i_rgb_raw_data_offset;
	sc_fifo_in<unsigned char>   i_bit_per_pixel;
	sc_fifo_in<unsigned short>  i_byte_per_pixel;
	sc_fifo_in<uint8_t*>        i_image_s;
	sc_fifo_in<uint8_t*>        i_image_t;

	sc_fifo_out<unsigned int>   o_width;
	sc_fifo_out<unsigned int>   o_height;
	sc_fifo_out<unsigned int>   o_rgb_raw_data_offset;
	sc_fifo_out<unsigned char>  o_bit_per_pixel;
	sc_fifo_out<unsigned short> o_byte_per_pixel;
	sc_fifo_out<uint8_t*>       o_image_t;
	sc_fifo_out<unsigned int>   o_left_quarter_to_sobel;

	sc_event *i_readDone_event, *o_sobelDone_event, *i_again_event;

	SC_CTOR(Sobel) {
		SC_THREAD(sobel);
	}

private:
	unsigned int   width;
	unsigned int   height;
	unsigned int   rgb_raw_data_offset;
	unsigned char  bit_per_pixel;
	unsigned short byte_per_pixel;
	unsigned char  *image_s;     // source image array
	unsigned char  *image_t;     // target image array
	unsigned int   left_quarter_to_sobel;
	void sobel();
};

#endif