#include "top.h"
#include "write_bmp.h"

void Write_bmp::write_bmp() {
    unsigned int file_size; // file size
    // bitmap header
    unsigned char header[54] = {
        0x42,        // identity : B
        0x4d,        // identity : M
        0, 0, 0, 0,  // file size
        0, 0,        // reserved1
        0, 0,        // reserved2
        54, 0, 0, 0, // RGB data offset
        40, 0, 0, 0, // struct BITMAPINFOHEADER size
        0, 0, 0, 0,  // bmp width
        0, 0, 0, 0,  // bmp height
        1, 0,        // planes
        24, 0,       // bit per pixel
        0, 0, 0, 0,  // compression
        0, 0, 0, 0,  // data size
        0, 0, 0, 0,  // h resolution
        0, 0, 0, 0,  // v resolution
        0, 0, 0, 0,  // used colors
        0, 0, 0, 0   // important colors
    };



    while (true) {
        wait(*i_sobelDone_event);
        width = i_width.read();
        height = i_height.read();
        rgb_raw_data_offset = i_rgb_raw_data_offset.read();
        bit_per_pixel = i_bit_per_pixel.read();
        byte_per_pixel = i_byte_per_pixel.read();
        left_quarter_to_sobel = i_left_quarter_to_sobel.read();
        image_t = i_image_t.read();
        printf("write\n");
        FILE *fp_t = NULL;                 // target file handler
        fp_t = fopen("lena_sobel.bmp", "wb");
        if (fp_t == NULL) {
            printf("fopen fname_t error\n");
            return;
        }

        // file size
        file_size = width * height * byte_per_pixel + rgb_raw_data_offset;
        header[2] = (unsigned char)(file_size & 0x000000ff);
        header[3] = (file_size >> 8)  & 0x000000ff;
        header[4] = (file_size >> 16) & 0x000000ff;
        header[5] = (file_size >> 24) & 0x000000ff;

        // width
        header[18] = width & 0x000000ff;
        header[19] = (width >> 8)  & 0x000000ff;
        header[20] = (width >> 16) & 0x000000ff;
        header[21] = (width >> 24) & 0x000000ff;

        // height
        header[22] = height & 0x000000ff;
        header[23] = (height >> 8)  & 0x000000ff;
        header[24] = (height >> 16) & 0x000000ff;
        header[25] = (height >> 24) & 0x000000ff;

        // bit per pixel
        header[28] = bit_per_pixel;

        // write header
        fwrite(header, sizeof(unsigned char), rgb_raw_data_offset, fp_t);

        // write image
        fwrite(image_t, sizeof(unsigned char), (size_t)(long)width * height * byte_per_pixel, fp_t);
        fclose(fp_t);

        if (left_quarter_to_sobel > 0) {
            wait(1, SC_NS);
            o_again_event->notify();
        }

    }
}