#ifndef _WRITE_BMP_H_
#define _WRITE_BMP_H_
#include <systemc>
using namespace sc_core;

SC_MODULE(Write_bmp) {
public:
	sc_fifo_in<unsigned int>   i_width;
	sc_fifo_in<unsigned int>   i_height;
	sc_fifo_in<unsigned int>   i_rgb_raw_data_offset;
	sc_fifo_in<unsigned char>  i_bit_per_pixel;
	sc_fifo_in<unsigned short> i_byte_per_pixel;
	sc_fifo_in<uint8_t*>       i_image_t;
	sc_fifo_in<unsigned int>   i_left_quarter_to_sobel;

	sc_event *i_sobelDone_event, *o_again_event;

	SC_CTOR(Write_bmp) {
		SC_THREAD(write_bmp);
	}

private:
	unsigned int   width;
	unsigned int   height;
	unsigned int   rgb_raw_data_offset;
	unsigned char  bit_per_pixel;
	unsigned short byte_per_pixel;
	unsigned int   left_quarter_to_sobel;
	unsigned char  *image_t;     // target image array
	void write_bmp();
};

#endif