#include "top.h"
#include "read_bmp.h"

void Read_bmp::read_bmp() {
	FILE *fp_s = NULL;                 // source file handler
	fp_s = fopen("lena.bmp", "rb");
	if (fp_s == NULL) {
		printf("fopen fp_s error\n");
		return;
	}

	// move offset to 10 to find rgb raw data offset
	fseek(fp_s, 10, SEEK_SET);
	fread(&rgb_raw_data_offset, sizeof(unsigned int), 1, fp_s);

	// move offset to 18 to get width & height;
	fseek(fp_s, 18, SEEK_SET);
	fread(&width,  sizeof(unsigned int), 1, fp_s);
	fread(&height, sizeof(unsigned int), 1, fp_s);

	// get bit per pixel
	fseek(fp_s, 28, SEEK_SET);
	fread(&bit_per_pixel, sizeof(unsigned short), 1, fp_s);
	byte_per_pixel = bit_per_pixel / 8;

	// move offset to rgb_raw_data_offset to get RGB raw data
	fseek(fp_s, rgb_raw_data_offset, SEEK_SET);

	image_s = (unsigned char *)malloc((size_t)width * height * byte_per_pixel);
	if (image_s == NULL) {
		printf("malloc images_s error\n");
		return;
	}

	image_t = (unsigned char *)malloc((size_t)width * height * byte_per_pixel);
	if (image_t == NULL) {
		printf("malloc image_t error\n");
		return;
	}

	fread(image_s, sizeof(unsigned char), (size_t)(long)width * height * byte_per_pixel, fp_s);
	fclose(fp_s);

	o_image_s.write(image_s);
	o_image_t.write(image_t);
	o_width.write(width);
	o_height.write(height);
	o_rgb_raw_data_offset.write(rgb_raw_data_offset);
	o_bit_per_pixel.write(bit_per_pixel);
	o_byte_per_pixel.write(byte_per_pixel);

	wait(1, SC_NS);
	o_readDone_event->notify();
}
