# Report

## Problem requirements
- Wrap a sobel module with TLM 2.0 sockets.
- All modules will be connected through point-to-point TLM.
- All modules will communicate through TLM blocking transports.

## Architecture
![architecture](tlm_architecture.PNG)

## Implementation
- The two module ReadTLM and WriteTLM are master, i.e., each module has initiator socket. Each module can launch blocking transport. And the module SobelTLM is slave, i.e., the module has two target sockets, one for ReadTLM and the other for WriteTLM.
- In ReadTLM.cpp, I put "unsigned int width", "unsigned int height" and "unsigned int rgb_raw_data_offset" into unsigned int in struct union, and transport the data that data type is unsigned char[4] in struct union, because the write_to_socket() function only accept the data that data type is unsigned char. And it's easy to transport bit_per_pixel and byte_per_pixel, since their data type are unsigned char.
- In SobelTLM.cpp, one transport functions is responsible for writing the master's data to fifo, and the other one is responsible for writing the data that is calculated with sobel algorithm into fifo.
- In WriteTLM.cpp, using read_from_socket() to get data, and put the unsigned char type of data into the corresponding data type.
- Because the concept of the blocking transport, if we call the blocking transport function, but the fifo is empty, execution will return to systemc kernel.

## Compile, run and display
- Edit the "Makefile" to perform a sequence of commands to build an application.
- Type "make" in the command line to generate executable file.
- Make sure the file "lena.bmp" is present in the current folder.
- Type "./sobel.exe" in the command line to generate output picture.
- Type "display lena_sobel.bmp &" in the command line to show output picture.

## Result
![result](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw3_tlm_point_to_point/lena_sobel.bmp)

## Discussions and conclusions
- Learn to use "union" to store data. It's useful!!
- Learn the concept of TLM-2.0 blocking transport.
- Learn the method read_from_socket and write_to_socket to transport data.