#include "ReadTLM.h"

ReadTLM::ReadTLM( sc_module_name n ): sc_module( n ), initiator( "initiator" ), flag(1)
{
    SC_THREAD( read_bmp );
}

void ReadTLM::read_bmp() {
    while ( flag > 0 )
    {
        FILE *fp_s = NULL;                 // source file handler
        fp_s = fopen("lena.bmp", "rb");
        if (fp_s == NULL) {
            printf("fopen fp_s error\n");
            return;
        }
        // move offset to 10 to find rgb raw data offset
        fseek(fp_s, 10, SEEK_SET);
        fread(&rgb_raw_data_offset, sizeof(unsigned int), 1, fp_s);

        // move offset to 18 to get width & height;
        fseek(fp_s, 18, SEEK_SET);
        fread(&width,  sizeof(unsigned int), 1, fp_s);
        fread(&height, sizeof(unsigned int), 1, fp_s);

        // get bit per pixel
        fseek(fp_s, 28, SEEK_SET);
        fread(&bit_per_pixel, sizeof(unsigned short), 1, fp_s);
        byte_per_pixel = bit_per_pixel / 8;

        // move offset to rgb_raw_data_offset to get RGB raw data
        fseek(fp_s, rgb_raw_data_offset, SEEK_SET);

        image_s = (unsigned char *)malloc((size_t)width * height * byte_per_pixel);
        if (image_s == NULL) {
            printf("malloc images_s error\n");
            return;
        }

        image_t = (unsigned char *)malloc((size_t)width * height * byte_per_pixel);
        if (image_t == NULL) {
            printf("malloc image_t error\n");
            return;
        }

        fread(image_s, sizeof(unsigned char), (size_t)(long)width * height * byte_per_pixel, fp_s);
        fclose(fp_s);

        word tmp;
        // unsigned char data[4];
        unsigned char mask_int[4] = {0xff, 0xff, 0xff, 0xff};

        tmp.uint = width;
        initiator.write_to_socket( 0, mask_int, tmp.uc, 4);

        tmp.uint = height;
        initiator.write_to_socket( 1, mask_int, tmp.uc, 4);

        tmp.uint = rgb_raw_data_offset;
        initiator.write_to_socket( 2, mask_int, tmp.uc, 4);

        tmp.uc[0] = bit_per_pixel;
        tmp.uc[1] = byte_per_pixel;
        initiator.write_to_socket( 3, mask_int, tmp.uc, 4);

        // declare a struct image_info which is defined in Top.h
        image_info info;
        // define the value of each member in struct
        info.image_s = image_s;
        info.image_t = image_t;

        mask = (unsigned char *) malloc(sizeof(image_info));
        for ( int i = 0; i < sizeof(image_info) / sizeof(unsigned char); i++ )
            mask[i] = 0xff;

        flag -= 1;
        // std::cout << "read done" << std::endl;
        wait(1, SC_NS);
        // std::cout <<  name() <<" is done at "<< sc_time_stamp() << std::endl;
        initiator.write_to_socket( 4, mask, (unsigned char*)(&info), sizeof(image_info) / sizeof(unsigned char));
    }

}
