#ifndef INITIATOR_H_
#define INITIATOR_H_
#include <systemc>
using namespace sc_core;

#include "tlm"
#include "tlm_utils/simple_initiator_socket.h"

class Initiator: public sc_module
{
public:
    tlm_utils::simple_initiator_socket<Initiator>  i_skt;

    SC_HAS_PROCESS( Initiator );
    Initiator( sc_module_name n );

    int read_from_socket( unsigned long int addr,
            unsigned char mask[],
            unsigned char rdata[],
            int dataLen );

    int write_to_socket( unsigned long int addr,
            unsigned char mask[],
            unsigned char wdata[],
            int dataLen );
    
    void do_trans( tlm::tlm_generic_payload &trans );
    tlm::tlm_generic_payload  trans;
};

typedef struct image_info {
    // unsigned int   width;
    // unsigned int   height;
    // unsigned int   rgb_raw_data_offset;
    // unsigned char  bit_per_pixel;
    // unsigned char  byte_per_pixel;
    unsigned char* image_s;     // source image array
    unsigned char* image_t;     // target image array
} image_info;

// typedef union word{
//     int sint;
//     unsigned int uint;
//     unsigned char uc[4];
// } word;
#endif
