# Report

## Problem requirements
- Wrap a sobel module with TLM 2.0 sockets.
- All modules will be connected through TLM bus.
- All modules will communicate through TLM blocking transports.

## Architecture
![architecture](bus_architecture.PNG)

## Memory map
- #define SOBEL_INPUT_BASE           (0x00000000)
- #define SOBEL_INPUT_WIDTH_OFFSET   (0x00000000)
- #define SOBEL_INPUT_HEIGHT_OFFSET  (0x00000004)
- #define SOBEL_INPUT_RGB_OFFSET     (0x00000008)
- #define SOBEL_INPUT_BIT_OFFSET     (0x0000000c)
- #define SOBEL_INPUT_BYTE_OFFSET    (0x0000000d)
- #define SOBEL_INPUT_IMAGES_OFFSET  (0x00000010)
- #define SOBEL_INPUT_IMAGET_OFFSET  (0x00000018)
- #define SOBEL_INPUT_SIZE           (0x00000020)
- #define SOBEL_OUTPUT_BASE          (0x00000100)
- #define SOBEL_OUTPUT_WIDTH_OFFSET  (0x00000000)
- #define SOBEL_OUTPUT_HEIGHT_OFFSET (0x00000004)
- #define SOBEL_OUTPUT_RGB_OFFSET    (0x00000008)
- #define SOBEL_OUTPUT_BIT_OFFSET    (0x0000000c)
- #define SOBEL_OUTPUT_BYTE_OFFSET   (0x0000000d)
- #define SOBEL_OUTPUT_IMAGES_OFFSET (0x00000010)
- #define SOBEL_OUTPUT_IMAGET_OFFSET (0x00000018)
- #define SOBEL_OUTPUT_SIZE          (0x00000020)

## Implementation
- First of all, I defined the memory map in the sobel_tlm.h to assign the memory location where data was stored, so that the blocking transport function can read data from correct memory location or write data into correct memory location.
- In the main_tlm.cpp, the SimpleBus is instantiated with two target socket and two initiator socket. And I binding the initiator socket from ReadTLM with the target socket on the bus. WriteTLM is the same. Then I use the method bindTargetSocket() in SimpleBus to binding the initiator socket on the bus with the target socket from the slave. Also the (memory base), (memory size - 1) and the mask to let bus to route the write_to_socket from the master to the correct slave. At first, the bus will determine which I/O interval the address in the transaction is located. And route this transaction to the right initiator socket on the bus. A new transport will be launched to the right slave.
- In the SobelTLM.cpp, the switch condition in the transport function is the data address offset rather than the actual data address. Because the address here is masked at the bus.

## Compile, run and display
- Edit the "Makefile" to perform a sequence of commands to build an application.
- Type "make" in the command line to generate executable file.
- Make sure the file "lena.bmp" is present in the current folder.
- Type "./sobel.exe" in the command line to generate output picture.
- Type "display lena_sobel.bmp &" in the command line to show output picture.

## Result
![result](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw4_tlm_bus/lena_sobel.bmp)

## Discussions and conclusions
- Learn the concept of bus module.
- Learn the concept of bus interconnect, i.e., binding the initiator socket from master with target socket on the bus. In addition, binding the initiator socket on the bus with target socket from slave.
- Learn the concept of memory map.