#ifndef _SOBEL_H_
#define _SOBEL_H_
#include <systemc>
using namespace sc_core;

class Sobel: public sc_module
{
public:
    SC_HAS_PROCESS( Sobel );
    Sobel( sc_module_name n);

    sc_fifo_in<unsigned int>     i_uint_width_height_rgb;
    sc_fifo_in<unsigned char>    i_uchar_bit_byte;
    sc_fifo_in<unsigned char*>   i_uchar_ptr_images_imaget;

    sc_fifo_out<unsigned int>    o_uint_width_height_rgb;
    sc_fifo_out<unsigned char>   o_uchar_bit_byte;
    sc_fifo_out<unsigned char*>  o_uchar_ptr_images_imaget;

private:
    // define variable used in SobelTLM.cpp
    unsigned int   width;
    unsigned int   height;
    unsigned int   rgb_raw_data_offset;
    unsigned char  bit_per_pixel;
    unsigned char  byte_per_pixel;
    unsigned char* image_s;     // source image array
    unsigned char* image_t;     // target image array
    void sobel();
};

#endif