#ifndef _SOBELTLM_H_
#define _SOBELTLM_H_
#include <systemc>
using namespace sc_core;

#include "tlm"
#include "tlm_utils/simple_target_socket.h"
#include "Sobel.h"

class SobelTLM: public sc_module
{
public:
    SC_HAS_PROCESS( SobelTLM );
    SobelTLM( sc_module_name n);
    tlm_utils::simple_target_socket<SobelTLM> t_skt_before_sobel;
    tlm_utils::simple_target_socket<SobelTLM> t_skt_after_sobel;
private:
    // define fifo to receive data from before_sobel_transport and read data in sobel()

    sc_fifo<unsigned int>    fifo_rs_uint_width_height_rgb;
    sc_fifo<unsigned char>   fifo_rs_uchar_bit_byte;
    sc_fifo<unsigned char*>  fifo_rs_uchar_ptr_images_imaget;

    sc_fifo<unsigned int>    fifo_sw_uint_width_height_rgb;
    sc_fifo<unsigned char>   fifo_sw_uchar_bit_byte;
    sc_fifo<unsigned char*>  fifo_sw_uchar_ptr_images_imaget;

    Sobel * sobel_ptr;

private:
    // declare transport function and some variable used in transport function
    void before_sobel_transport( tlm::tlm_generic_payload &payload, sc_core::sc_time &delay );
    void after_sobel_transport( tlm::tlm_generic_payload &payload, sc_core::sc_time &delay );
    unsigned int   base_offset;
};

#endif