# Report

## Problem requirements
- Implement sobel module in Chisel3 and co-sim with TLM.
- Design a convolution module in Chisel and run simulations with TLM program from previous homework.

## Architecture
![architecture](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw5_chisel_tlm/architecture.PNG)

## Memory map
- #define SOBEL_BASE                 (0x00000000)
- #define SOBEL_INPUT_WIDTH_OFFSET   (0x00000000)
- #define SOBEL_INPUT_HEIGHT_OFFSET  (0x00000004)
- #define SOBEL_INPUT_RGB_OFFSET     (0x00000008)
- #define SOBEL_INPUT_BIT_OFFSET     (0x0000000c)
- #define SOBEL_INPUT_BYTE_OFFSET    (0x0000000d)
- #define SOBEL_INPUT_IMAGES_OFFSET  (0x00000010)
- #define SOBEL_INPUT_IMAGET_OFFSET  (0x00000018)
- #define SOBEL_OUTPUT_WIDTH_OFFSET  (0x00000020)
- #define SOBEL_OUTPUT_HEIGHT_OFFSET (0x00000024)
- #define SOBEL_OUTPUT_RGB_OFFSET    (0x00000028)
- #define SOBEL_OUTPUT_BIT_OFFSET    (0x0000002c)
- #define SOBEL_OUTPUT_BYTE_OFFSET   (0x0000002d)
- #define SOBEL_OUTPUT_IMAGES_OFFSET (0x00000030)
- #define SOBEL_OUTPUT_IMAGET_OFFSET (0x00000038)
- #define SOBEL_SIZE                 (0X00000040)
- #define HWSOBEL_BASE               (0x00000100)
- #define HWSOBEL_INPUT_OFFSET       (0x00000000)
- #define HWSOBEL_OUTPUT_OFFSET      (0x00000004)
- #define HWSOBEL_SIZE               (0x00000008)

## Implementation
- In sobel.scala, the sobel module has 8 input ports for 3x3 image, but without the value of the center of the matrix. Since we don't need the value for convolution. And the module has 2 output ports. One for X direction convolution result, the other for the Y direction convolution result. The circuit only need one step() to get the result.
- In the systemc module, there are three master module(ReadTLM, SobelTLM, WriteTLM) and two slave module(SobelTLM, Sobel). Each module are connected with the bus.
- In the SobelTLM module, when we get 9 gray level value in the for loop, we send 8 value rather than 9 by write_to_socket() two times to transport the data to the sobel module, and recieve two convolution result, one for X-dir, one for Y-dir by read_from_socket() two times.

## Compile, run and display
- In the top directory
- mkdir build
- cd build
- cmake ..
- make 
- ./src/cxxgcdbench && ./src/tlmgcdbench && ./sc_module/MAIN

## Result
![result](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw5_chisel_tlm/result.PNG)
![lena_sobel](http://gitlab.larc-nthu.net/106061565/ee6470_106061565/raw/master/hw5_chisel_tlm/lena_sobel.bmp)

## Discussions and conclusions
- Learn the syntax of the scala and compile the chisel circuit into C++ code.
- Write testbench for C++ simulation and TLM simulation.
- Wrapper the sobel model with tlm interface.