#ifndef _READTLM_H_
#define _READTLM_H_
#include <systemc>
using namespace sc_core;

#include "tlm"
#include "Initiator.h"

class ReadTLM: public sc_module {
public:
    SC_HAS_PROCESS( ReadTLM );
    ReadTLM( sc_module_name n );
    Initiator initiator;
private:
    unsigned int   width;
    unsigned int   height;
    unsigned int   rgb_raw_data_offset;
    unsigned char  bit_per_pixel;
    unsigned char  byte_per_pixel;
    unsigned char* image_s;     // source image array
    unsigned char* image_t;     // target image array

    unsigned char  *mask;
    int flag;
    void read_bmp();

    const sc_dt::uint64 sobel_input_width_addr;
    const sc_dt::uint64 sobel_input_height_addr;
    const sc_dt::uint64 sobel_input_rgb_addr;
    const sc_dt::uint64 sobel_input_bit_addr;
    const sc_dt::uint64 sobel_input_byte_addr;
    const sc_dt::uint64 sobel_input_images_addr;
    const sc_dt::uint64 sobel_input_imaget_addr;
};


#endif

