#ifndef _SOBELTLM_H_
#define _SOBELTLM_H_
#include <systemc>
using namespace sc_core;

#include "tlm"
#include "tlm_utils/simple_target_socket.h"
#include "Initiator.h"
#include "Sobel.h"

class SobelTLM: public sc_module
{
public:
    SC_HAS_PROCESS( SobelTLM );
    SobelTLM( sc_module_name n);
    tlm_utils::simple_target_socket<SobelTLM> t_skt_sobel;
    Initiator initiator;
    // tlm_utils::simple_target_socket<SobelTLM> t_skt_after_sobel;
private:
    sc_fifo<unsigned int>    fifo_rs_uint_width_height_rgb;
    sc_fifo<unsigned char>   fifo_rs_uchar_bit_byte;
    sc_fifo<unsigned char*>  fifo_rs_uchar_ptr_images_imaget;

    sc_fifo<unsigned int>    fifo_sw_uint_width_height_rgb;
    sc_fifo<unsigned char>   fifo_sw_uchar_bit_byte;
    sc_fifo<unsigned char*>  fifo_sw_uchar_ptr_images_imaget;
private:
    unsigned int   base_offset;
    unsigned int   width;
    unsigned int   height;
    unsigned int   rgb_raw_data_offset;
    unsigned char  bit_per_pixel;
    unsigned char  byte_per_pixel;
    unsigned char* image_s;     // source image array
    unsigned char* image_t;     // target image array
    void sobel();
    void sobel_transport( tlm::tlm_generic_payload &payload, sc_core::sc_time &delay );
    void send_numbers(const unsigned char a, const unsigned char b, const unsigned char c, const unsigned char d);
    unsigned int recv_result();
};

#endif
