macro(append_list_each var target_list suffix)
	# clear the variable first.
	set(${var})
	foreach(item ${${target_list}})
		set(${var} ${${var}} "${item}${suffix}")
	endforeach(item)
endmacro(append_list_each)

macro(append_list_each_list var target_list middle_item suffix_list)
	set(${var})
	foreach(item ${${suffix_list}})
		append_list_each(TEMP_VAR ${target_list} ${middle_item}${item})
		set(${var} ${${var}} "${TEMP_VAR}")
	endforeach(item)
endmacro(append_list_each_list)

macro(get_n_path var file_path times)
	set(${var} ${file_path})
	#if times == 1, it still runs twice.
	foreach(i RANGE 1 ${times})
		get_filename_component(${var} ${${var}} PATH)
	endforeach(i)
endmacro(get_n_path)
