
////////////////////////////////////////////////////////////////////////////////
//
//                W R I T T E N   B Y   I M P E R A S   I G E N
//
//                             Version 20170511.0
//
////////////////////////////////////////////////////////////////////////////////

// This file constructs the platform.
// This file should NOT need to be edited.

#include "ovpworld.org/modelSupport/tlmDecoder/1.0/tlm/tlmDecoder.hpp"
#include "ovpworld.org/memory/ram/1.0/tlm/tlmMemory.hpp"
#include "ovpworld.org/processor/or1k/1.0/tlm/processor.igen.hpp"
#include "national.ovpworld.org/peripheral/16550/1.0/tlm/pse.igen.hpp"


using namespace sc_core;
////////////////////////////////////////////////////////////////////////////////
//                                simple Class
////////////////////////////////////////////////////////////////////////////////

class simple : public sc_module {

  public:
    simple (sc_module_name name);

    tlmModule             Platform;
    tlmDecoder            bus1;
    tlmRam                ram1;
    tlmRam                ram2;
    or1k                  cpu1;
    _16550                uart1;
    extension             or1kNewlib_0;

}; /* simple */

////////////////////////////////////////////////////////////////////////////////
//                             simple Constructor
////////////////////////////////////////////////////////////////////////////////

simple::simple (sc_module_name name)
    : sc_module (name)
    , Platform ("")
    , bus1(Platform, "bus1", 2, 3)
    , ram1 (Platform, "ram1", 0xfffff)
    , ram2 (Platform, "ram2", 0xffff)
    , cpu1 ( Platform, "cpu1")
    , uart1 (Platform, "uart1")
    , or1kNewlib_0(cpu1, opVLNVString (NULL, "ovpworld.org", "semihosting", "or1kNewlib", "1.0", OP_EXTENSION, 1), "or1kNewlib_0")
{

    // bus1 masters
    bus1.connect(cpu1.INSTRUCTION);
    bus1.connect(cpu1.DATA);

    // bus1 slaves
    bus1.connect(uart1.bport1, 0x90000000, 0x90000007); // Peripheral  (0)

    bus1.connect(ram1.sp1,0x0, 0xfffff); // Memory (1)

    bus1.connect(ram2.sp1,0xffff0000, 0xffffffff); // Memory (2)


    // Net connections
    uart1.intOut(cpu1.intr0);

    uart1.diagnosticLevelSet(1);
}
