// See LICENSE for license details.

package example

import chisel3._

class Mux2 extends Module {
  val io = IO(new Bundle {
    val sel = Input(UInt(1.W))
    val in0 = Input(UInt(10.W))
    val in1 = Input(UInt(10.W))
    val out = Output(UInt(10.W))
  })
  // io.out := (io.sel & io.in1) | (~io.sel & io.in0)
  when(io.sel === 0.U) { io.out := io.in0 }
  when(io.sel === 1.U) { io.out := io.in1 }
  
}

class sobel extends Module {
  val io = IO(new Bundle {
    val m0 = Input(UInt(10.W))
    val m1 = Input(UInt(10.W))
    val m2 = Input(UInt(10.W))
    val m3 = Input(UInt(10.W))
    // val m4 = Input(UInt(10.W))
    val m5 = Input(UInt(10.W))
    val m6 = Input(UInt(10.W))
    val m7 = Input(UInt(10.W))
    val m8 = Input(UInt(10.W))
    val out_X = Output(UInt(10.W))
    val out_Y = Output(UInt(10.W))

  })

  // val RGB_22 = RegNext( (io.in_R + io.in_G + io.in_B) / 3.U )
  // val RGB_21 = RegNext(RGB_22)
  // val RGB_20 = RegNext(RGB_21)
  // val RGB_12 = RegNext(RGB_20)
  // val RGB_11 = RegNext(RGB_12)
  // val RGB_10 = RegNext(RGB_11)
  // val RGB_02 = RegNext(RGB_10)
  // val RGB_01 = RegNext(RGB_02)
  // val RGB_00 = RegNext(RGB_01)

  val X_dir = Module(new Mux2())
  val row_0 = io.m0 + io.m1 + io.m1 + io.m2
  val row_2 = io.m6 + io.m7 + io.m7 + io.m8
  X_dir.io.sel := Mux(row_0 > row_2, 1.U, 0.U)
  X_dir.io.in0 := row_2 - row_0
  X_dir.io.in1 := row_0 - row_2

  val Y_dir = Module(new Mux2())
  val col_0 = io.m0 + io.m3 + io.m3 + io.m6
  val col_2 = io.m2 + io.m5 + io.m5 + io.m8
  Y_dir.io.sel := Mux(col_0 > col_2, 1.U, 0.U)
  Y_dir.io.in0 := col_2 - col_0
  Y_dir.io.in1 := col_0 - col_2

  io.out_X := X_dir.io.out
  io.out_Y := Y_dir.io.out
  // io.out_val := X_dir.io.out * X_dir.io.out + Y_dir.io.out * Y_dir.io.out
}
