// See LICENSE for license details.

package example.test
import chisel3.iotesters
import chisel3.iotesters.{ChiselFlatSpec, Driver, PeekPokeTester}
import example.sobel

class SobelUnitTester(c: sobel) extends PeekPokeTester(c) {

  private val gcd = c

  for (t <- 0 until 100) {
    // Input data initialization
    // val R = Array.fill(9){ 0 }
    // val G = Array.fill(9){ 0 }
    // val B = Array.fill(9){ 0 }
    // for (i <- 0 until 9) {
    //   R(i) = rnd.nextInt(255)
    //   G(i) = rnd.nextInt(255)
    //   B(i) = rnd.nextInt(255)
    // }

    val test_m0 = rnd.nextInt(255) 
    val test_m1 = rnd.nextInt(255)
    val test_m2 = rnd.nextInt(255)
    val test_m3 = rnd.nextInt(255)

    val test_m5 = rnd.nextInt(255)
    val test_m6 = rnd.nextInt(255)
    val test_m7 = rnd.nextInt(255)
    val test_m8 = rnd.nextInt(255)

    // Software result
    // val v00 = (R(8) + G(8) + B(8))/3
    // val v01 = (R(7) + G(7) + B(7))/3
    // val v02 = (R(6) + G(6) + B(6))/3
    // val v10 = (R(5) + G(5) + B(5))/3
    // val v11 = (R(4) + G(4) + B(4))/3
    // val v12 = (R(3) + G(3) + B(3))/3
    // val v20 = (R(2) + G(2) + B(2))/3
    // val v21 = (R(1) + G(1) + B(1))/3
    // val v22 = (R(0) + G(0) + B(0))/3
    val expected_sobel_x = Math.abs(( test_m0 + 2*test_m1 + test_m2 ) - ( test_m6 + 2*test_m7 + test_m8 ))
    val expected_sobel_y = Math.abs(( test_m0 + 2*test_m3 + test_m6 ) - ( test_m2 + 2*test_m5 + test_m8 ))
    // val expected_sobel = expected_sobel_x * expected_sobel_x + expected_sobel_y * expected_sobel_y

    // Verification
    // for (i <- 0 until 9) {
    //   poke(gcd.io.in_R, R(i))
    //   poke(gcd.io.in_G, G(i))
    //   poke(gcd.io.in_B, B(i))
    //   step(1)
    // }
    poke(gcd.io.m0, test_m0)
    poke(gcd.io.m1, test_m1)
    poke(gcd.io.m2, test_m2)
    poke(gcd.io.m3, test_m3)
    poke(gcd.io.m5, test_m5)
    poke(gcd.io.m6, test_m6)
    poke(gcd.io.m7, test_m7)
    poke(gcd.io.m8, test_m8)
    step(1)
    
    expect(gcd.io.out_X, expected_sobel_x)
    expect(gcd.io.out_Y, expected_sobel_y)
    // expect(gcd.io.out_val, expected_sobel) 
  }
}

class SobelTester extends ChiselFlatSpec {
  private val backendNames = Array[String]("firrtl", "verilator")
  for ( backendName <- backendNames ) {
    "sobel" should s"calculate proper greatest common denominator (with $backendName)" in {
      Driver(() => new sobel, backendName) {
        c => new SobelUnitTester(c)
      } should be (true)
    }
  }
}
