`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif

module Mux2(
  input        io_sel,
  input  [9:0] io_in0,
  input  [9:0] io_in1,
  output [9:0] io_out
);
  wire [9:0] _GEN_1;
  assign _GEN_1 = io_sel ? io_in1 : io_in0;
  assign io_out = _GEN_1;
endmodule
module sobel(
  input        clock,
  input        reset,
  input  [9:0] io_m0,
  input  [9:0] io_m1,
  input  [9:0] io_m2,
  input  [9:0] io_m3,
  input  [9:0] io_m5,
  input  [9:0] io_m6,
  input  [9:0] io_m7,
  input  [9:0] io_m8,
  output [9:0] io_out_X,
  output [9:0] io_out_Y
);
  wire  X_dir_io_sel;
  wire [9:0] X_dir_io_in0;
  wire [9:0] X_dir_io_in1;
  wire [9:0] X_dir_io_out;
  wire [10:0] _T_12;
  wire [9:0] _T_13;
  wire [10:0] _T_14;
  wire [9:0] _T_15;
  wire [10:0] _T_16;
  wire [9:0] row_0;
  wire [10:0] _T_17;
  wire [9:0] _T_18;
  wire [10:0] _T_19;
  wire [9:0] _T_20;
  wire [10:0] _T_21;
  wire [9:0] row_2;
  wire  _T_22;
  wire [10:0] _T_26;
  wire [10:0] _T_27;
  wire [9:0] _T_28;
  wire [10:0] _T_29;
  wire [10:0] _T_30;
  wire [9:0] _T_31;
  wire  Y_dir_io_sel;
  wire [9:0] Y_dir_io_in0;
  wire [9:0] Y_dir_io_in1;
  wire [9:0] Y_dir_io_out;
  wire [10:0] _T_32;
  wire [9:0] _T_33;
  wire [10:0] _T_34;
  wire [9:0] _T_35;
  wire [10:0] _T_36;
  wire [9:0] col_0;
  wire [10:0] _T_37;
  wire [9:0] _T_38;
  wire [10:0] _T_39;
  wire [9:0] _T_40;
  wire [10:0] _T_41;
  wire [9:0] col_2;
  wire  _T_42;
  wire [10:0] _T_46;
  wire [10:0] _T_47;
  wire [9:0] _T_48;
  wire [10:0] _T_49;
  wire [10:0] _T_50;
  wire [9:0] _T_51;
  Mux2 X_dir (
    .io_sel(X_dir_io_sel),
    .io_in0(X_dir_io_in0),
    .io_in1(X_dir_io_in1),
    .io_out(X_dir_io_out)
  );
  Mux2 Y_dir (
    .io_sel(Y_dir_io_sel),
    .io_in0(Y_dir_io_in0),
    .io_in1(Y_dir_io_in1),
    .io_out(Y_dir_io_out)
  );
  assign _T_12 = io_m0 + io_m1;
  assign _T_13 = _T_12[9:0];
  assign _T_14 = _T_13 + io_m1;
  assign _T_15 = _T_14[9:0];
  assign _T_16 = _T_15 + io_m2;
  assign row_0 = _T_16[9:0];
  assign _T_17 = io_m6 + io_m7;
  assign _T_18 = _T_17[9:0];
  assign _T_19 = _T_18 + io_m7;
  assign _T_20 = _T_19[9:0];
  assign _T_21 = _T_20 + io_m8;
  assign row_2 = _T_21[9:0];
  assign _T_22 = row_0 > row_2;
  assign _T_26 = row_2 - row_0;
  assign _T_27 = $unsigned(_T_26);
  assign _T_28 = _T_27[9:0];
  assign _T_29 = row_0 - row_2;
  assign _T_30 = $unsigned(_T_29);
  assign _T_31 = _T_30[9:0];
  assign _T_32 = io_m0 + io_m3;
  assign _T_33 = _T_32[9:0];
  assign _T_34 = _T_33 + io_m3;
  assign _T_35 = _T_34[9:0];
  assign _T_36 = _T_35 + io_m6;
  assign col_0 = _T_36[9:0];
  assign _T_37 = io_m2 + io_m5;
  assign _T_38 = _T_37[9:0];
  assign _T_39 = _T_38 + io_m5;
  assign _T_40 = _T_39[9:0];
  assign _T_41 = _T_40 + io_m8;
  assign col_2 = _T_41[9:0];
  assign _T_42 = col_0 > col_2;
  assign _T_46 = col_2 - col_0;
  assign _T_47 = $unsigned(_T_46);
  assign _T_48 = _T_47[9:0];
  assign _T_49 = col_0 - col_2;
  assign _T_50 = $unsigned(_T_49);
  assign _T_51 = _T_50[9:0];
  assign io_out_X = X_dir_io_out;
  assign io_out_Y = Y_dir_io_out;
  assign X_dir_io_sel = _T_22;
  assign X_dir_io_in0 = _T_28;
  assign X_dir_io_in1 = _T_31;
  assign Y_dir_io_sel = _T_42;
  assign Y_dir_io_in0 = _T_48;
  assign Y_dir_io_in1 = _T_51;
endmodule
