#ifndef GLOBAL_H_
#define GLOBAL_H_

#include <stdlib.h>
#include <stdio.h>

/* from "jmorecfg.h" */
typedef short INT16;
typedef long INT32;             
typedef unsigned char JSAMPLE;
#define BITS_IN_JSAMPLE 8
#define MAXJSAMPLE	255
#define CENTERJSAMPLE	128
#define FALSE	0
#define TRUE	1

/* from "jpeglib.h" */
#define DCTSIZE           8   /* The basic DCT block is 8x8 samples */
#define DCTSIZE2          64

/* from "jpegint.h" */
#ifdef RIGHT_SHIFT_IS_UNSIGNED
#define SHIFT_TEMPS     INT32 shift_temp;
#define RIGHT_SHIFT(x,shft)  \
        ((shift_temp = (x)) < 0 ? \
         (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
         (shift_temp >> (shft)))
#else
#define SHIFT_TEMPS
#define RIGHT_SHIFT(x,shft)     ((x) >> (shft))
#endif

#define MBSIZE                 16      /* macro block size */
//#define MAXPIXELS              399872  /* max. number of pixels */
#define MAXPIXELS              4194304  /* max. number of pixels */

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

/* Global Variable */
EXTERN char *program;                    /* program name */
EXTERN FILE *ppm_fp;                     /* PPM file pointer */
EXTERN FILE *jpg_fp;                     /* JPEG file pointer */
EXTERN int org_w;                        /* original image width */
EXTERN int org_h;                        /* original image height */
EXTERN int exp_w;                        /* expanded image width */
EXTERN int exp_h;                        /* expanded image height */
EXTERN unsigned char comp_r[MAXPIXELS];  /* R component */
EXTERN unsigned char comp_g[MAXPIXELS];  /* G component */
EXTERN unsigned char comp_b[MAXPIXELS];  /* B component */
EXTERN unsigned char comp_y[MAXPIXELS];  /* Y component */
EXTERN unsigned char comp_cb[MAXPIXELS]; /* Cb component */
EXTERN unsigned char comp_cr[MAXPIXELS]; /* Cr component */

#ifdef MAIN
int jpeg_natural_order[DCTSIZE2+16] = { /* from "jutils.c" */
  0,  1,  8, 16,  9,  2,  3, 10,
 17, 24, 32, 25, 18, 11,  4,  5,
 12, 19, 26, 33, 40, 48, 41, 34,
 27, 20, 13,  6,  7, 14, 21, 28,
 35, 42, 49, 56, 57, 50, 43, 36,
 29, 22, 15, 23, 30, 37, 44, 51,
 58, 59, 52, 45, 38, 31, 39, 46,
 53, 60, 61, 54, 47, 55, 62, 63,
 63, 63, 63, 63, 63, 63, 63, 63, /* extra entries for safety in decoder */
 63, 63, 63, 63, 63, 63, 63, 63
};
int qtbl0[DCTSIZE2] = {          /* Quantize table no. 0 */
  0x08, 0x06, 0x05, 0x08, 0x0c, 0x14, 0x1a, 0x1f,
  0x06, 0x06, 0x07, 0x0a, 0x0d, 0x1d, 0x1e, 0x1c,
  0x07, 0x07, 0x08, 0x0c, 0x14, 0x1d, 0x23, 0x1c,
  0x07, 0x09, 0x0b, 0x0f, 0x1a, 0x2c, 0x28, 0x1f,
  0x09, 0x0b, 0x13, 0x1c, 0x22, 0x37, 0x34, 0x27,
  0x0c, 0x12, 0x1c, 0x20, 0x29, 0x34, 0x39, 0x2e,
  0x19, 0x20, 0x27, 0x2c, 0x34, 0x3d, 0x3c, 0x33,
  0x24, 0x2e, 0x30, 0x31, 0x38, 0x32, 0x34, 0x32
  };
int qtbl1[DCTSIZE2] = {          /* Quantize table no. 1 */
  0x09, 0x09, 0x0c, 0x18, 0x32, 0x32, 0x32, 0x32,
  0x09, 0x0b, 0x0d, 0x21, 0x32, 0x32, 0x32, 0x32,
  0x0c, 0x0d, 0x1c, 0x32, 0x32, 0x32, 0x32, 0x32,
  0x18, 0x21, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32,
  0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32,
  0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32,
  0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32,
  0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32
  };
unsigned char dc_bits0[17] = {     /* DC Huffman table no. 0 */
  0x00,
  0x00, 0x01, 0x05, 0x01, 0x01, 0x01, 0x01, 0x01,
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
unsigned char dc_huffval0[256] = { /* DC Huffman table no. 0 */
  0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
  0x08, 0x09, 0x0a, 0x0b
};
unsigned char ac_bits0[17] = {     /* AC Huffman table no. 0 */
  0x00,
  0x00, 0x02, 0x01, 0x03, 0x03, 0x02, 0x04, 0x03,
  0x05, 0x05, 0x04, 0x04, 0x00, 0x00, 0x01, 0x7d
};
unsigned char ac_huffval0[256] = { /* AC Huffman table no. 0 */
  0x01, 0x02, 0x03, 0x00, 0x04, 0x11, 0x05, 0x12,
  0x21, 0x31, 0x41, 0x06, 0x13, 0x51, 0x61, 0x07,
  0x22, 0x71, 0x14, 0x32, 0x81, 0x91, 0xa1, 0x08,
  0x23, 0x42, 0xb1, 0xc1, 0x15, 0x52, 0xd1, 0xf0,
  0x24, 0x33, 0x62, 0x72, 0x82, 0x09, 0x0a, 0x16,
  0x17, 0x18, 0x19, 0x1a, 0x25, 0x26, 0x27, 0x28,
  0x29, 0x2a, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
  0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
  0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
  0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
  0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
  0x7a, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
  0x8a, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98,
  0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
  0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6,
  0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4, 0xc5,
  0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4,
  0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xe1, 0xe2,
  0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea,
  0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
  0xf9, 0xfa
};
unsigned char dc_bits1[17] = {     /* DC Huffman table no. 1 */
  0x00,
  0x00, 0x03, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
  0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00
};
unsigned char dc_huffval1[256] = { /* DC Huffman table no. 1 */
  0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
  0x08, 0x09, 0x0a, 0x0b 
};
unsigned char ac_bits1[17] = {     /* AC Huffman table no. 1 */
  0x00,
  0x00, 0x02, 0x01, 0x02, 0x04, 0x04, 0x03, 0x04,
  0x07, 0x05, 0x04, 0x04, 0x00, 0x01, 0x02, 0x77
};
unsigned char ac_huffval1[256] = { /* AC Huffman table no. 1 */
  0x00, 0x01, 0x02, 0x03, 0x11, 0x04, 0x05, 0x21,
  0x31, 0x06, 0x12, 0x41, 0x51, 0x07, 0x61, 0x71,
  0x13, 0x22, 0x32, 0x81, 0x08, 0x14, 0x42, 0x91,
  0xa1, 0xb1, 0xc1, 0x09, 0x23, 0x33, 0x52, 0xf0,
  0x15, 0x62, 0x72, 0xd1, 0x0a, 0x16, 0x24, 0x34,
  0xe1, 0x25, 0xf1, 0x17, 0x18, 0x19, 0x1a, 0x26,
  0x27, 0x28, 0x29, 0x2a, 0x35, 0x36, 0x37, 0x38,
  0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
  0x49, 0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
  0x59, 0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68,
  0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
  0x79, 0x7a, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
  0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95, 0x96,
  0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5,
  0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4,
  0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3,
  0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2,
  0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda,
  0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
  0xea, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
  0xf9, 0xfa
};
#else
extern int jpeg_natural_order[];
extern int qtbl0[];
extern int qtbl1[];
extern unsigned char dc_bits0[];
extern unsigned char dc_huffval0[];
extern unsigned char ac_bits0[];
extern unsigned char ac_huffval0[];
extern unsigned char dc_bits1[];
extern unsigned char dc_huffval1[];
extern unsigned char ac_bits1[];
extern unsigned char ac_huffval1[];
#endif


#endif
