#include "global.h"
#include <string.h>

void read_ppm( FILE *ppm_fp )
{
  int i, j;
  char str[256];
  int maxjsample;
  int c;
  unsigned char *r, *g, *b;

  if (fscanf(ppm_fp, "%s %d %d %d ",
             str, &org_w, &org_h, &maxjsample) == EOF) {
    fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
    exit(1);
  }
  exp_w = MBSIZE * (org_w/MBSIZE);
  exp_w = (exp_w < org_w) ? exp_w + MBSIZE : exp_w;
  exp_h = MBSIZE * (org_h/MBSIZE);
  exp_h = (exp_h < org_h) ? exp_h + MBSIZE : exp_h;
  if (strcmp(str, "P6")) {
    fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
    exit(1);
  }
  if (exp_w <= 0 || exp_h <= 0 || (exp_w*exp_h > MAXPIXELS)) {
    fprintf(stderr, "%s: image too big\n", "cjpeg");
    exit(1);
  }
  if (maxjsample != MAXJSAMPLE) {
    fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
    exit(1);
  }
	//to be modified
  r = &comp_r[0];
  g = &comp_g[0];
  b = &comp_b[0];
  for (i = 0; i < org_h; i++) {
    for (j = 0; j < org_w; j++) {
      if ((c = fgetc(ppm_fp)) == EOF) {
        fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
        exit(1);
      }
      *r++ = c;
      if ((c = fgetc(ppm_fp)) == EOF) {
        fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
        exit(1);
      }
      *g++ = c;
      if ((c = fgetc(ppm_fp)) == EOF) {
        fprintf(stderr, "%s: error in PPM file\n", "cjpeg");
        exit(1);
      }
      *b++ = c;
    }
  }
	//
}

void dump_ppm()
{
	int i, j;
	printf ( "int exp_h = %u;\nint exp_w = %u;\n", exp_h, exp_w );
	printf ( "int org_h = %u;\nint org_w = %u;\n", org_h, org_w );
	//printf ( "comp_b[%u, %u] = %8u, comp_b[%u, %u] = %8u, comp_b[%u, %u] = %8u\n", 
	/*
	printf ( "comp_r[%u] = %8u;\n comp_g[%u] = %8u;\n comp_b[%u] = %8u;\n", 
			i*org_w+j, comp_r[i*org_w+j],
			i*org_w+j, comp_g[i*org_w+j],
			i*org_w+j, comp_b[i*org_w+j]
	);
	*/
	printf ( "unsigned char comp_r[%d] = {\n", org_h*org_w );
	for ( i = 0; i< org_h; i++ )
	{
		for ( j = 0; j< org_w; j++ )
		{
			printf ( "%d", comp_r[i*org_w+j] );
			if ( i == org_h-1 && j == org_w-1 )
				break;
			printf ( "," );
		}
	}
	printf ( "};\n" );

	printf ( "unsigned char comp_g[%d] = {\n", org_h*org_w );
	for ( i = 0; i< org_h; i++ )
	{
		for ( j = 0; j< org_w; j++ )
		{
			printf ( "%d", comp_g[i*org_w+j] );
			if ( i == org_h-1 && j == org_w-1 )
				break;
			printf ( "," );
		}
	}
	printf ( "};\n" );
	
	printf ( "unsigned char comp_b[%d] = {\n", org_h*org_w );
	for ( i = 0; i< org_h; i++ )
	{
		for ( j = 0; j< org_w; j++ )
		{
			printf ( "%d", comp_b[i*org_w+j] );
			if ( i == org_h-1 && j == org_w-1 )
				break;
			printf ( "," );
		}
	}
	printf ( "};\n" );
}
