#include "mmio.h"
#include <stdio.h>
// #include "image_20x20.h"
#include "image_arr.h"

#define GCD_m0 0x2000
#define GCD_m1 0x2004
#define GCD_m2 0x2008
#define GCD_m3 0x200c
#define GCD_m5 0x2010
#define GCD_m6 0x2014
#define GCD_m7 0x2018
#define GCD_m8 0x201c
#define GCD_out_X 0x2020
#define GCD_out_Y 0x2024
#define GCD_v 0x2028
#define GCD_e 0x202c

#define MASK_N 2
#define MASK_X 3
#define MASK_Y 3
#define WHITE  255
#define BLACK  0
#define HEIGHT 20
#define WIDTH 20
#define BIT_PER_PIXEL 24

unsigned long read_cycles(void)
{
	unsigned long cycles;
	asm volatile ("rdcycle %0" : "=r" (cycles));
	return cycles;
}

/*
   void GCD(int a, int b) {

   write_reg(GCD_ENABLE, 1);
   write_reg(GCD_A, a);
   write_reg(GCD_B, b);
   write_reg(GCD_ENABLE, 0);

   while(!read_reg(GCyyD_VALID)) break;

   printf("A = %d, B = %d, GCD = %d\n", a, b, (int*)read_reg(GCD_OUT));

   }
 */

/*
   int main(void)
   {
   unsigned long start = read_cycles();

// GCD Testing   
GCD(10, 15);
GCD(100, 15);
GCD(1, 15);
GCD(4, 15);
GCD(2, 23);
GCD(100, 10);

unsigned long end = read_cycles();
printf("Took %lu cycles and end %lu start %lu\n",end - start,end,start);

return 0;
}
 */

int main() {
	unsigned int  x, y, i, v, u;             // for loop counter
	unsigned char R, G, B;         // color of R, G, B
	double val[MASK_N] = {0.0};
	int adjustX, adjustY, xBound, yBound;
	double total;
	unsigned int width = 20, height = 20;      // image width, image height
	unsigned int byte_per_pixel = 3;     // byte per pixel
	double threshold = 90.0;
	// sobel mask
	int mask[MASK_N][MASK_X][MASK_Y] = {
		{   { -1, -2, -1},
			{0 , 0, 0},
			{1 , 2, 1}
		},

		{   { -1, 0, 1},
			{ -2, 0, 2},
			{ -1, 0, 1}
		}
	};
	int error_cnt = 0;
	int sw_hw_cnt = 0;
	//  for (y = 0; y != height; ++y) {
	//      for (x = 0; x != width; ++x) {
	unsigned long start, end;
	start = read_cycles();
	for (y = 0; y != 20; ++y) {
		for (x = 0; x != 20; ++x) {
			// for (i = 0; i != MASK_N; ++i) {
			adjustX = (MASK_X % 2) ? 1 : 0;
			adjustY = (MASK_Y % 2) ? 1 : 0;
			xBound = MASK_X / 2;
			yBound = MASK_Y / 2;

			val[i] = 0.0;
			int cnt = 0;
			unsigned int tmp[9] = {0};
			for (v = -yBound; v != yBound + adjustY; ++v) {
				for (u = -xBound; u != xBound + adjustX; ++u) {
					if (x + u >= 0 && x + u < width && y + v >= 0 && y + v < height) {
						R = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 2);
						G = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 1);
						B = *(image_s_arr + byte_per_pixel * (width * (y + v) + (x + u)) + 0);
						// val[i] += color_to_int(R, G, B) * mask[i][u + xBound][v + yBound];
						// val[i] += ((int)R+(int)G+(int)B)/3 * mask[i][u + xBound][v + yBound];
						// printf("R: %d, G: %d, B: %d\n", (int)R, (int)G, (int)B);
						tmp[cnt] = ((int)R+(int)G+(int)B)/3;
					}
					cnt++;
				}
			}
			//}
			/*
			   int abc;
			   for(abc=0; abc<9; abc++)
			   printf("tmp[%d]: %u\n", abc, tmp[abc]);
			 */
			write_reg(GCD_e, 1);
			write_reg(GCD_m0, tmp[0]);
			write_reg(GCD_m1, tmp[1]);
			write_reg(GCD_m2, tmp[2]);
			write_reg(GCD_m3, tmp[3]);
			write_reg(GCD_m5, tmp[5]);
			write_reg(GCD_m6, tmp[6]);
			write_reg(GCD_m7, tmp[7]);
			write_reg(GCD_m8, tmp[8]);
			write_reg(GCD_e, 0);
			// (int*)read_reg(GCD_out_X)
			// (int*)read_reg(GCD_out_Y)
			// write_reg(GCD_out_X, a);
			// write_reg(GCD_out_Y, a);


			total = 0.0;
			// for (i = 0; i != MASK_N; ++i) {
			//     total += val[i] * val[i];
			// }
			while(!read_reg(GCD_v)) {}
			// printf("%d, %d\n", (int)read_reg(GCD_out_X), (int)read_reg(GCD_out_Y));
			// int ans_x = (int)read_reg(GCD_out_X), ans_y = (int)read_reg(GCD_out_Y);
			// total = ans_x * ans_x + ans_y * ans_y;
			// printf("GCD_out_X: %d, GCD_out_Y: %d\n\n", read_reg(GCD_out_X), read_reg(GCD_out_Y));
			/*
			   sw_hw_cnt++;
			   if((unsigned int)total == (unsigned int)read_reg(GCD_square)) {
			   printf("%d. Pass!, total in software: %u, total in hardware: %u\n", sw_hw_cnt, (unsigned int)total, (unsigned int)read_reg(GCD_square));
			   } else {
			   printf("%d. Fail!, total in software: %u, total in hardware: %u\n", sw_hw_cnt, (unsigned int)total, (unsigned int)read_reg(GCD_square));
			   }
			 */
			// total = sqrt(total);
			total = read_reg(GCD_out_X) * read_reg(GCD_out_X) + read_reg(GCD_out_Y) * read_reg(GCD_out_Y);			
			// printf("total before sqrt: %d\n", (int)total);
			if (total <= 1)
				continue;
			else {
				double l = 1, r = total, sol, mid;
				while (l <= r) {
					mid = l + (r - l) / 2;
					if (mid <= total / mid) {
						l = mid + 1;
						sol = mid;
					}
					else
						r = mid - 1;
				}
				total = sol;
			}
			// printf("total after sqrt: %d\n\n", (int)total);
			// printf("x = %d, y = %d.\n", x, y);
			if (total - threshold >= 0) {
				// black
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 2) != BLACK) {
					error_cnt++;
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 1) != BLACK) {
					error_cnt++;
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 0) != BLACK) {
					error_cnt++;
				}

				//*(image_t_array + byte_per_pixel * (width * y + x) + 2) = BLACK;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 1) = BLACK;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 0) = BLACK;
			} else {
				// white
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 2) != WHITE) {
					error_cnt++;
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 1) != WHITE) {
					error_cnt++;
				}
				if (*(image_t_arr + byte_per_pixel * (width * y + x) + 0) != WHITE) {
					error_cnt++;
				}

				//*(image_t_array + byte_per_pixel * (width * y + x) + 2) = WHITE;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 1) = WHITE;
				//*(image_t_array + byte_per_pixel * (width * y + x) + 0) = WHITE;
			}
		}
	}
	end = read_cycles();
	printf("Took %lu cycles and end %lu start %lu\n",end - start,end,start);
	printf("error_cnt: %d\n", error_cnt);
	if(error_cnt == 0) {
		printf("Success!!\n");
	} else {
		printf("Failed!!\n");
	} 
}

/*
   void printf_err_msg(int x, int y, int index, int color){
   printf("Failed at x = %d, y = %d.\n", x, y);
   printf("*(image_t_arr + byte_per_pixel * (width * y + x) + 2): %u\n", *(image_t_arr + 24 * (20 * y + x) + index));
   if(color == 0)
   printf("Golden is BLACK(0).\n");
   else
   printf("Golden is WHITE(255).\n");  
   }
 */

