// See LICENSE for license details.

package example.test

import chisel3.iotesters.{ChiselFlatSpec, Driver, PeekPokeTester}
import example.hybrid

class hybridUnitTester(c: hybrid) extends PeekPokeTester(c) {
  
  private val hybrid = c
  for (t <- 0 until 1000) {
    val R0 = rnd.nextInt(255) 
    val R1 = rnd.nextInt(255)
    val R2 = rnd.nextInt(255)
    val R3 = rnd.nextInt(255)
    val R4 = rnd.nextInt(255)
    val R5 = rnd.nextInt(255)
    val R6 = rnd.nextInt(255)
    val R7 = rnd.nextInt(255)
    val R8 = rnd.nextInt(255)

    val expected_median_R_0 = List(R1, R3, R4, R5, R7).sorted
    val expected_median_R_1 = List(R0, R2, R4, R6, R8).sorted
    val expected_median_R_2 = List(expected_median_R_0(2), expected_median_R_1(2), R4).sorted

    val G0 = rnd.nextInt(255) 
    val G1 = rnd.nextInt(255)
    val G2 = rnd.nextInt(255)
    val G3 = rnd.nextInt(255)
    val G4 = rnd.nextInt(255)
    val G5 = rnd.nextInt(255)
    val G6 = rnd.nextInt(255)
    val G7 = rnd.nextInt(255)
    val G8 = rnd.nextInt(255)

    val expected_median_G_0 = List(G1, G3, G4, G5, G7).sorted
    val expected_median_G_1 = List(G0, G2, G4, G6, G8).sorted
    val expected_median_G_2 = List(expected_median_G_0(2), expected_median_G_1(2), G4).sorted

    val B0 = rnd.nextInt(255) 
    val B1 = rnd.nextInt(255)
    val B2 = rnd.nextInt(255)
    val B3 = rnd.nextInt(255)
    val B4 = rnd.nextInt(255)
    val B5 = rnd.nextInt(255)
    val B6 = rnd.nextInt(255)
    val B7 = rnd.nextInt(255)
    val B8 = rnd.nextInt(255)

    val expected_median_B_0 = List(B1, B3, B4, B5, B7).sorted
    val expected_median_B_1 = List(B0, B2, B4, B6, B8).sorted
    val expected_median_B_2 = List(expected_median_B_0(2), expected_median_B_1(2), B4).sorted

    poke(hybrid.io.R0, R0)
    poke(hybrid.io.R1, R1)
    poke(hybrid.io.R2, R2)
    poke(hybrid.io.R3, R3)
    poke(hybrid.io.R4, R4)
    poke(hybrid.io.R5, R5)
    poke(hybrid.io.R6, R6)
    poke(hybrid.io.R7, R7)
    poke(hybrid.io.R8, R8)
    poke(hybrid.io.G0, G0)
    poke(hybrid.io.G1, G1)
    poke(hybrid.io.G2, G2)
    poke(hybrid.io.G3, G3)
    poke(hybrid.io.G4, G4)
    poke(hybrid.io.G5, G5)
    poke(hybrid.io.G6, G6)
    poke(hybrid.io.G7, G7)
    poke(hybrid.io.G8, G8)
    poke(hybrid.io.B0, B0)
    poke(hybrid.io.B1, B1)
    poke(hybrid.io.B2, B2)
    poke(hybrid.io.B3, B3)
    poke(hybrid.io.B4, B4)
    poke(hybrid.io.B5, B5)
    poke(hybrid.io.B6, B6)
    poke(hybrid.io.B7, B7)
    poke(hybrid.io.B8, B8)
    poke(hybrid.io.e, 1)
    step(1)
    poke(hybrid.io.e, 0)
    step(20)
    expect(hybrid.io.ansR, expected_median_R_2(1))
    expect(hybrid.io.ansG, expected_median_G_2(1))
    expect(hybrid.io.ansB, expected_median_B_2(1))
  }
}

class GCDTester extends ChiselFlatSpec {
  private val backendNames = Array[String]("verilator")
  for ( backendName <- backendNames ) {
    "hybrid" should s"calculate proper greatest common denominator (with $backendName)" in {
      Driver(() => new hybrid, backendName) {
        c => new hybridUnitTester(c)
      } should be (true)
    }
  }
}
