# package name : OVP
# package components : OVPsim, CpuManager, OR1K

# OVP_FOUND
# OVP_LIBRARIES
# OVP_INCLUDE_DIRS




if(NOT DEFINED ENV{IMPERAS_HOME} AND NOT DEFINED ${IMPERAS_HOME})
	message(FATAL_ERROR "Please set IMPERAS_HOME env variable.")
endif()

set(IMPERAS_HOME $ENV{IMPERAS_HOME})

# Find OVP runtime library
find_library(OVP_RUNTIME_LOADER
	NAMES RuntimeLoader 
	PATHS ${IMPERAS_HOME}/bin/Liunx64 ${IMPERAS_HOME}/bin/Liunx32)


# set the include directories
set(OVP_INCLUDE_DIRS 
	"${IMPERAS_HOME}/ImperasLib/source"
	"${IMPERAS_HOME}/ImpPublic/include/host"
	CACHE STRING "The included directories of OVP"
)

set(OVP_ROOT_DIR ${IMPERAS_HOME})
find_package_handle_standard_args(OVP DEFAULT_MSG 
	OVP_ROOT_DIR OVP_INCLUDE_DIRS OVP_RUNTIME_LOADER
)
mark_as_advanced(OVP_INCLUDE_DIRS OVP_RUNTIME_LOADER)
set(OVP_LIBRARIES ${OVP_RUNTIME_LOADER})
