// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "Vhybrid__Syms.h"


//======================

void Vhybrid::trace (VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addCallback (&Vhybrid::traceInit, &Vhybrid::traceFull, &Vhybrid::traceChg, this);
}
void Vhybrid::traceInit(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->open()
    Vhybrid* t=(Vhybrid*)userthis;
    Vhybrid__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    if (!Verilated::calcUnusedSigs()) vl_fatal(__FILE__,__LINE__,__FILE__,"Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    vcdp->scopeEscape(' ');
    t->traceInitThis (vlSymsp, vcdp, code);
    vcdp->scopeEscape('.');
}
void Vhybrid::traceFull(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->dump()
    Vhybrid* t=(Vhybrid*)userthis;
    Vhybrid__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    t->traceFullThis (vlSymsp, vcdp, code);
}

//======================


void Vhybrid::traceInitThis(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    vcdp->module(vlSymsp->name()); // Setup signal names
    // Body
    {
	vlTOPp->traceInitThis__1(vlSymsp, vcdp, code);
    }
}

void Vhybrid::traceFullThis(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vlTOPp->traceFullThis__1(vlSymsp, vcdp, code);
    }
    // Final
    vlTOPp->__Vm_traceActivity = 0U;
}

void Vhybrid::traceInitThis__1(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->declBit  (c+42,"clock",-1);
	vcdp->declBit  (c+43,"reset",-1);
	vcdp->declBus  (c+44,"io_R0",-1,7,0);
	vcdp->declBus  (c+45,"io_R1",-1,7,0);
	vcdp->declBus  (c+46,"io_R2",-1,7,0);
	vcdp->declBus  (c+47,"io_R3",-1,7,0);
	vcdp->declBus  (c+48,"io_R4",-1,7,0);
	vcdp->declBus  (c+49,"io_R5",-1,7,0);
	vcdp->declBus  (c+50,"io_R6",-1,7,0);
	vcdp->declBus  (c+51,"io_R7",-1,7,0);
	vcdp->declBus  (c+52,"io_R8",-1,7,0);
	vcdp->declBus  (c+53,"io_G0",-1,7,0);
	vcdp->declBus  (c+54,"io_G1",-1,7,0);
	vcdp->declBus  (c+55,"io_G2",-1,7,0);
	vcdp->declBus  (c+56,"io_G3",-1,7,0);
	vcdp->declBus  (c+57,"io_G4",-1,7,0);
	vcdp->declBus  (c+58,"io_G5",-1,7,0);
	vcdp->declBus  (c+59,"io_G6",-1,7,0);
	vcdp->declBus  (c+60,"io_G7",-1,7,0);
	vcdp->declBus  (c+61,"io_G8",-1,7,0);
	vcdp->declBus  (c+62,"io_B0",-1,7,0);
	vcdp->declBus  (c+63,"io_B1",-1,7,0);
	vcdp->declBus  (c+64,"io_B2",-1,7,0);
	vcdp->declBus  (c+65,"io_B3",-1,7,0);
	vcdp->declBus  (c+66,"io_B4",-1,7,0);
	vcdp->declBus  (c+67,"io_B5",-1,7,0);
	vcdp->declBus  (c+68,"io_B6",-1,7,0);
	vcdp->declBus  (c+69,"io_B7",-1,7,0);
	vcdp->declBus  (c+70,"io_B8",-1,7,0);
	vcdp->declBit  (c+71,"io_e",-1);
	vcdp->declBus  (c+72,"io_ansR",-1,7,0);
	vcdp->declBus  (c+73,"io_ansG",-1,7,0);
	vcdp->declBus  (c+74,"io_ansB",-1,7,0);
	vcdp->declBit  (c+42,"hybrid clock",-1);
	vcdp->declBit  (c+43,"hybrid reset",-1);
	vcdp->declBus  (c+44,"hybrid io_R0",-1,7,0);
	vcdp->declBus  (c+45,"hybrid io_R1",-1,7,0);
	vcdp->declBus  (c+46,"hybrid io_R2",-1,7,0);
	vcdp->declBus  (c+47,"hybrid io_R3",-1,7,0);
	vcdp->declBus  (c+48,"hybrid io_R4",-1,7,0);
	vcdp->declBus  (c+49,"hybrid io_R5",-1,7,0);
	vcdp->declBus  (c+50,"hybrid io_R6",-1,7,0);
	vcdp->declBus  (c+51,"hybrid io_R7",-1,7,0);
	vcdp->declBus  (c+52,"hybrid io_R8",-1,7,0);
	vcdp->declBus  (c+53,"hybrid io_G0",-1,7,0);
	vcdp->declBus  (c+54,"hybrid io_G1",-1,7,0);
	vcdp->declBus  (c+55,"hybrid io_G2",-1,7,0);
	vcdp->declBus  (c+56,"hybrid io_G3",-1,7,0);
	vcdp->declBus  (c+57,"hybrid io_G4",-1,7,0);
	vcdp->declBus  (c+58,"hybrid io_G5",-1,7,0);
	vcdp->declBus  (c+59,"hybrid io_G6",-1,7,0);
	vcdp->declBus  (c+60,"hybrid io_G7",-1,7,0);
	vcdp->declBus  (c+61,"hybrid io_G8",-1,7,0);
	vcdp->declBus  (c+62,"hybrid io_B0",-1,7,0);
	vcdp->declBus  (c+63,"hybrid io_B1",-1,7,0);
	vcdp->declBus  (c+64,"hybrid io_B2",-1,7,0);
	vcdp->declBus  (c+65,"hybrid io_B3",-1,7,0);
	vcdp->declBus  (c+66,"hybrid io_B4",-1,7,0);
	vcdp->declBus  (c+67,"hybrid io_B5",-1,7,0);
	vcdp->declBus  (c+68,"hybrid io_B6",-1,7,0);
	vcdp->declBus  (c+69,"hybrid io_B7",-1,7,0);
	vcdp->declBus  (c+70,"hybrid io_B8",-1,7,0);
	vcdp->declBit  (c+71,"hybrid io_e",-1);
	vcdp->declBus  (c+72,"hybrid io_ansR",-1,7,0);
	vcdp->declBus  (c+73,"hybrid io_ansG",-1,7,0);
	vcdp->declBus  (c+74,"hybrid io_ansB",-1,7,0);
	vcdp->declBus  (c+1,"hybrid cnt",-1,4,0);
	// Tracing: hybrid _RAND_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1848
	// Tracing: hybrid _T_36 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1849
	// Tracing: hybrid _T_38 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1850
	// Tracing: hybrid _T_39 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1851
	// Tracing: hybrid _GEN_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1852
	// Tracing: hybrid _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1853
	vcdp->declBus  (c+2,"hybrid cnt_1",-1,4,0);
	// Tracing: hybrid _RAND_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1855
	// Tracing: hybrid _T_44 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1856
	// Tracing: hybrid _T_46 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1857
	// Tracing: hybrid _T_47 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1858
	// Tracing: hybrid _T_49 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1859
	// Tracing: hybrid _T_50 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1860
	// Tracing: hybrid _T_53 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1861
	// Tracing: hybrid _GEN_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1862
	// Tracing: hybrid _GEN_3 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1863
	// Tracing: hybrid _GEN_4 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1864
	vcdp->declBit  (c+42,"hybrid R_0_clock",-1);
	vcdp->declBus  (c+45,"hybrid R_0_io_x0",-1,7,0);
	vcdp->declBus  (c+47,"hybrid R_0_io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_0_io_x2",-1,7,0);
	vcdp->declBus  (c+49,"hybrid R_0_io_x3",-1,7,0);
	vcdp->declBus  (c+51,"hybrid R_0_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_0_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid R_0_io_e",-1);
	vcdp->declBus  (c+3,"hybrid R_0_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid R_1_clock",-1);
	vcdp->declBus  (c+44,"hybrid R_1_io_x0",-1,7,0);
	vcdp->declBus  (c+46,"hybrid R_1_io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_1_io_x2",-1,7,0);
	vcdp->declBus  (c+50,"hybrid R_1_io_x3",-1,7,0);
	vcdp->declBus  (c+52,"hybrid R_1_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_1_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid R_1_io_e",-1);
	vcdp->declBus  (c+4,"hybrid R_1_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid R_2_clock",-1);
	vcdp->declBus  (c+3,"hybrid R_2_io_x0",-1,7,0);
	vcdp->declBus  (c+4,"hybrid R_2_io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_2_io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_2_io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid R_2_io_cnt_1",-1,4,0);
	vcdp->declBus  (c+5,"hybrid R_2_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid G_0_clock",-1);
	vcdp->declBus  (c+54,"hybrid G_0_io_x0",-1,7,0);
	vcdp->declBus  (c+56,"hybrid G_0_io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_0_io_x2",-1,7,0);
	vcdp->declBus  (c+58,"hybrid G_0_io_x3",-1,7,0);
	vcdp->declBus  (c+60,"hybrid G_0_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_0_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid G_0_io_e",-1);
	vcdp->declBus  (c+6,"hybrid G_0_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid G_1_clock",-1);
	vcdp->declBus  (c+53,"hybrid G_1_io_x0",-1,7,0);
	vcdp->declBus  (c+55,"hybrid G_1_io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_1_io_x2",-1,7,0);
	vcdp->declBus  (c+59,"hybrid G_1_io_x3",-1,7,0);
	vcdp->declBus  (c+61,"hybrid G_1_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_1_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid G_1_io_e",-1);
	vcdp->declBus  (c+7,"hybrid G_1_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid G_2_clock",-1);
	vcdp->declBus  (c+6,"hybrid G_2_io_x0",-1,7,0);
	vcdp->declBus  (c+7,"hybrid G_2_io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_2_io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_2_io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid G_2_io_cnt_1",-1,4,0);
	vcdp->declBus  (c+8,"hybrid G_2_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid B_0_clock",-1);
	vcdp->declBus  (c+63,"hybrid B_0_io_x0",-1,7,0);
	vcdp->declBus  (c+65,"hybrid B_0_io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_0_io_x2",-1,7,0);
	vcdp->declBus  (c+67,"hybrid B_0_io_x3",-1,7,0);
	vcdp->declBus  (c+69,"hybrid B_0_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_0_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid B_0_io_e",-1);
	vcdp->declBus  (c+9,"hybrid B_0_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid B_1_clock",-1);
	vcdp->declBus  (c+62,"hybrid B_1_io_x0",-1,7,0);
	vcdp->declBus  (c+64,"hybrid B_1_io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_1_io_x2",-1,7,0);
	vcdp->declBus  (c+68,"hybrid B_1_io_x3",-1,7,0);
	vcdp->declBus  (c+70,"hybrid B_1_io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_1_io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid B_1_io_e",-1);
	vcdp->declBus  (c+10,"hybrid B_1_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid B_2_clock",-1);
	vcdp->declBus  (c+9,"hybrid B_2_io_x0",-1,7,0);
	vcdp->declBus  (c+10,"hybrid B_2_io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_2_io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_2_io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid B_2_io_cnt_1",-1,4,0);
	vcdp->declBus  (c+11,"hybrid B_2_io_z",-1,7,0);
	vcdp->declBit  (c+42,"hybrid R_2 clock",-1);
	vcdp->declBus  (c+3,"hybrid R_2 io_x0",-1,7,0);
	vcdp->declBus  (c+4,"hybrid R_2 io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_2 io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_2 io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid R_2 io_cnt_1",-1,4,0);
	vcdp->declBus  (c+5,"hybrid R_2 io_z",-1,7,0);
	vcdp->declBus  (c+12,"hybrid R_2 tbl_0",-1,7,0);
	// Tracing: hybrid R_2 _RAND_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1420
	vcdp->declBus  (c+5,"hybrid R_2 tbl_1",-1,7,0);
	// Tracing: hybrid R_2 _RAND_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1422
	vcdp->declBus  (c+13,"hybrid R_2 tbl_2",-1,7,0);
	// Tracing: hybrid R_2 _RAND_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1424
	// Tracing: hybrid R_2 _T_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1425
	// Tracing: hybrid R_2 _GEN_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1426
	// Tracing: hybrid R_2 _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1427
	// Tracing: hybrid R_2 _GEN_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1428
	// Tracing: hybrid R_2 _T_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1429
	// Tracing: hybrid R_2 _T_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1430
	// Tracing: hybrid R_2 _GEN_3 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1431
	// Tracing: hybrid R_2 _GEN_4 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1432
	// Tracing: hybrid R_2 _GEN_5 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1433
	// Tracing: hybrid R_2 _GEN_6 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1434
	// Tracing: hybrid R_2 _T_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1435
	// Tracing: hybrid R_2 _T_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1436
	// Tracing: hybrid R_2 _GEN_7 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1437
	// Tracing: hybrid R_2 _GEN_8 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1438
	// Tracing: hybrid R_2 _GEN_9 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1439
	// Tracing: hybrid R_2 _GEN_10 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1440
	// Tracing: hybrid R_2 _T_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1441
	// Tracing: hybrid R_2 _GEN_11 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1442
	// Tracing: hybrid R_2 _GEN_12 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1443
	// Tracing: hybrid R_2 _GEN_13 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1444
	// Tracing: hybrid R_2 _GEN_14 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1445
	// Tracing: hybrid R_2 _T_28 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1446
	// Tracing: hybrid R_2 _GEN_15 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1447
	// Tracing: hybrid R_2 _GEN_16 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1448
	// Tracing: hybrid R_2 _GEN_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1449
	// Tracing: hybrid R_2 _GEN_18 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1450
	// Tracing: hybrid R_2 _T_31 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1451
	// Tracing: hybrid R_2 _GEN_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1452
	// Tracing: hybrid R_2 _GEN_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1453
	// Tracing: hybrid R_2 _GEN_21 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1454
	// Tracing: hybrid R_2 _GEN_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1455
	// Tracing: hybrid R_2 _T_34 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1456
	// Tracing: hybrid R_2 _GEN_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1457
	// Tracing: hybrid R_2 _GEN_24 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1458
	// Tracing: hybrid R_2 _GEN_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1459
	// Tracing: hybrid R_2 _GEN_26 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1460
	vcdp->declBit  (c+42,"hybrid G_2 clock",-1);
	vcdp->declBus  (c+6,"hybrid G_2 io_x0",-1,7,0);
	vcdp->declBus  (c+7,"hybrid G_2 io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_2 io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_2 io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid G_2 io_cnt_1",-1,4,0);
	vcdp->declBus  (c+8,"hybrid G_2 io_z",-1,7,0);
	vcdp->declBus  (c+14,"hybrid G_2 tbl_0",-1,7,0);
	// Tracing: hybrid G_2 _RAND_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1420
	vcdp->declBus  (c+8,"hybrid G_2 tbl_1",-1,7,0);
	// Tracing: hybrid G_2 _RAND_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1422
	vcdp->declBus  (c+15,"hybrid G_2 tbl_2",-1,7,0);
	// Tracing: hybrid G_2 _RAND_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1424
	// Tracing: hybrid G_2 _T_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1425
	// Tracing: hybrid G_2 _GEN_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1426
	// Tracing: hybrid G_2 _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1427
	// Tracing: hybrid G_2 _GEN_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1428
	// Tracing: hybrid G_2 _T_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1429
	// Tracing: hybrid G_2 _T_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1430
	// Tracing: hybrid G_2 _GEN_3 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1431
	// Tracing: hybrid G_2 _GEN_4 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1432
	// Tracing: hybrid G_2 _GEN_5 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1433
	// Tracing: hybrid G_2 _GEN_6 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1434
	// Tracing: hybrid G_2 _T_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1435
	// Tracing: hybrid G_2 _T_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1436
	// Tracing: hybrid G_2 _GEN_7 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1437
	// Tracing: hybrid G_2 _GEN_8 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1438
	// Tracing: hybrid G_2 _GEN_9 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1439
	// Tracing: hybrid G_2 _GEN_10 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1440
	// Tracing: hybrid G_2 _T_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1441
	// Tracing: hybrid G_2 _GEN_11 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1442
	// Tracing: hybrid G_2 _GEN_12 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1443
	// Tracing: hybrid G_2 _GEN_13 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1444
	// Tracing: hybrid G_2 _GEN_14 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1445
	// Tracing: hybrid G_2 _T_28 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1446
	// Tracing: hybrid G_2 _GEN_15 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1447
	// Tracing: hybrid G_2 _GEN_16 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1448
	// Tracing: hybrid G_2 _GEN_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1449
	// Tracing: hybrid G_2 _GEN_18 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1450
	// Tracing: hybrid G_2 _T_31 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1451
	// Tracing: hybrid G_2 _GEN_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1452
	// Tracing: hybrid G_2 _GEN_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1453
	// Tracing: hybrid G_2 _GEN_21 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1454
	// Tracing: hybrid G_2 _GEN_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1455
	// Tracing: hybrid G_2 _T_34 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1456
	// Tracing: hybrid G_2 _GEN_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1457
	// Tracing: hybrid G_2 _GEN_24 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1458
	// Tracing: hybrid G_2 _GEN_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1459
	// Tracing: hybrid G_2 _GEN_26 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1460
	vcdp->declBit  (c+42,"hybrid B_2 clock",-1);
	vcdp->declBus  (c+9,"hybrid B_2 io_x0",-1,7,0);
	vcdp->declBus  (c+10,"hybrid B_2 io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_2 io_x2",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_2 io_cnt",-1,4,0);
	vcdp->declBus  (c+2,"hybrid B_2 io_cnt_1",-1,4,0);
	vcdp->declBus  (c+11,"hybrid B_2 io_z",-1,7,0);
	vcdp->declBus  (c+16,"hybrid B_2 tbl_0",-1,7,0);
	// Tracing: hybrid B_2 _RAND_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1420
	vcdp->declBus  (c+11,"hybrid B_2 tbl_1",-1,7,0);
	// Tracing: hybrid B_2 _RAND_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1422
	vcdp->declBus  (c+17,"hybrid B_2 tbl_2",-1,7,0);
	// Tracing: hybrid B_2 _RAND_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1424
	// Tracing: hybrid B_2 _T_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1425
	// Tracing: hybrid B_2 _GEN_0 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1426
	// Tracing: hybrid B_2 _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1427
	// Tracing: hybrid B_2 _GEN_2 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1428
	// Tracing: hybrid B_2 _T_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1429
	// Tracing: hybrid B_2 _T_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1430
	// Tracing: hybrid B_2 _GEN_3 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1431
	// Tracing: hybrid B_2 _GEN_4 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1432
	// Tracing: hybrid B_2 _GEN_5 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1433
	// Tracing: hybrid B_2 _GEN_6 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1434
	// Tracing: hybrid B_2 _T_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1435
	// Tracing: hybrid B_2 _T_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1436
	// Tracing: hybrid B_2 _GEN_7 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1437
	// Tracing: hybrid B_2 _GEN_8 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1438
	// Tracing: hybrid B_2 _GEN_9 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1439
	// Tracing: hybrid B_2 _GEN_10 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1440
	// Tracing: hybrid B_2 _T_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1441
	// Tracing: hybrid B_2 _GEN_11 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1442
	// Tracing: hybrid B_2 _GEN_12 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1443
	// Tracing: hybrid B_2 _GEN_13 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1444
	// Tracing: hybrid B_2 _GEN_14 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1445
	// Tracing: hybrid B_2 _T_28 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1446
	// Tracing: hybrid B_2 _GEN_15 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1447
	// Tracing: hybrid B_2 _GEN_16 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1448
	// Tracing: hybrid B_2 _GEN_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1449
	// Tracing: hybrid B_2 _GEN_18 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1450
	// Tracing: hybrid B_2 _T_31 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1451
	// Tracing: hybrid B_2 _GEN_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1452
	// Tracing: hybrid B_2 _GEN_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1453
	// Tracing: hybrid B_2 _GEN_21 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1454
	// Tracing: hybrid B_2 _GEN_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1455
	// Tracing: hybrid B_2 _T_34 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1456
	// Tracing: hybrid B_2 _GEN_23 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1457
	// Tracing: hybrid B_2 _GEN_24 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1458
	// Tracing: hybrid B_2 _GEN_25 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1459
	// Tracing: hybrid B_2 _GEN_26 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1460
	vcdp->declBit  (c+42,"hybrid R_0 clock",-1);
	vcdp->declBus  (c+45,"hybrid R_0 io_x0",-1,7,0);
	vcdp->declBus  (c+47,"hybrid R_0 io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_0 io_x2",-1,7,0);
	vcdp->declBus  (c+49,"hybrid R_0 io_x3",-1,7,0);
	vcdp->declBus  (c+51,"hybrid R_0 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_0 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid R_0 io_e",-1);
	vcdp->declBus  (c+3,"hybrid R_0 io_z",-1,7,0);
	vcdp->declBus  (c+18,"hybrid R_0 tbl_0",-1,7,0);
	// Tracing: hybrid R_0 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+19,"hybrid R_0 tbl_1",-1,7,0);
	// Tracing: hybrid R_0 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+3,"hybrid R_0 tbl_2",-1,7,0);
	// Tracing: hybrid R_0 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+20,"hybrid R_0 tbl_3",-1,7,0);
	// Tracing: hybrid R_0 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+21,"hybrid R_0 tbl_4",-1,7,0);
	// Tracing: hybrid R_0 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid R_0 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid R_0 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid R_0 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid R_0 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid R_0 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid R_0 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid R_0 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid R_0 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid R_0 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid R_0 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid R_0 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid R_0 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid R_0 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid R_0 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid R_0 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid R_0 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid R_0 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid R_0 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid R_0 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid R_0 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid R_0 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid R_0 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid R_0 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid R_0 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid R_0 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid R_0 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid R_0 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid R_0 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid R_0 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid R_0 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid R_0 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid R_0 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid R_0 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid R_0 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid R_0 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid R_0 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid R_0 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid R_0 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid R_0 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid R_0 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid R_0 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid R_0 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid R_0 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid R_0 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid R_0 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid R_0 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid R_0 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid R_0 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid R_0 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid R_0 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid R_0 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid R_0 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid R_0 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid R_0 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid R_0 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid R_0 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid R_0 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid R_0 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid R_0 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid R_0 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid R_0 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid R_0 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid R_0 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid R_0 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid R_0 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid R_0 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid R_0 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid R_0 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid R_0 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid R_0 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid R_0 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid R_0 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid R_0 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid R_0 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid R_0 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid R_0 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid R_0 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid R_0 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid R_0 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid R_0 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid R_0 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid R_0 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid R_0 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid R_0 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid R_0 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid R_0 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid R_0 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid R_0 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid R_0 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid R_0 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid R_0 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid R_0 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid R_0 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid R_0 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid R_0 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid R_0 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid R_0 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid R_0 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid R_0 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid R_0 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid R_0 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid R_0 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid R_0 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid R_0 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid R_0 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid R_0 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid R_0 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid R_0 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid R_0 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
	vcdp->declBit  (c+42,"hybrid R_1 clock",-1);
	vcdp->declBus  (c+44,"hybrid R_1 io_x0",-1,7,0);
	vcdp->declBus  (c+46,"hybrid R_1 io_x1",-1,7,0);
	vcdp->declBus  (c+48,"hybrid R_1 io_x2",-1,7,0);
	vcdp->declBus  (c+50,"hybrid R_1 io_x3",-1,7,0);
	vcdp->declBus  (c+52,"hybrid R_1 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid R_1 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid R_1 io_e",-1);
	vcdp->declBus  (c+4,"hybrid R_1 io_z",-1,7,0);
	vcdp->declBus  (c+22,"hybrid R_1 tbl_0",-1,7,0);
	// Tracing: hybrid R_1 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+23,"hybrid R_1 tbl_1",-1,7,0);
	// Tracing: hybrid R_1 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+4,"hybrid R_1 tbl_2",-1,7,0);
	// Tracing: hybrid R_1 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+24,"hybrid R_1 tbl_3",-1,7,0);
	// Tracing: hybrid R_1 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+25,"hybrid R_1 tbl_4",-1,7,0);
	// Tracing: hybrid R_1 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid R_1 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid R_1 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid R_1 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid R_1 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid R_1 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid R_1 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid R_1 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid R_1 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid R_1 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid R_1 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid R_1 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid R_1 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid R_1 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid R_1 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid R_1 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid R_1 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid R_1 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid R_1 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid R_1 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid R_1 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid R_1 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid R_1 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid R_1 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid R_1 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid R_1 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid R_1 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid R_1 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid R_1 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid R_1 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid R_1 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid R_1 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid R_1 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid R_1 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid R_1 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid R_1 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid R_1 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid R_1 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid R_1 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid R_1 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid R_1 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid R_1 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid R_1 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid R_1 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid R_1 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid R_1 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid R_1 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid R_1 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid R_1 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid R_1 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid R_1 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid R_1 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid R_1 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid R_1 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid R_1 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid R_1 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid R_1 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid R_1 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid R_1 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid R_1 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid R_1 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid R_1 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid R_1 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid R_1 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid R_1 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid R_1 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid R_1 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid R_1 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid R_1 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid R_1 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid R_1 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid R_1 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid R_1 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid R_1 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid R_1 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid R_1 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid R_1 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid R_1 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid R_1 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid R_1 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid R_1 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid R_1 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid R_1 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid R_1 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid R_1 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid R_1 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid R_1 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid R_1 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid R_1 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid R_1 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid R_1 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid R_1 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid R_1 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid R_1 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid R_1 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid R_1 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid R_1 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid R_1 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid R_1 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid R_1 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid R_1 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid R_1 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid R_1 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid R_1 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid R_1 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid R_1 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid R_1 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid R_1 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid R_1 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid R_1 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
	vcdp->declBit  (c+42,"hybrid G_0 clock",-1);
	vcdp->declBus  (c+54,"hybrid G_0 io_x0",-1,7,0);
	vcdp->declBus  (c+56,"hybrid G_0 io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_0 io_x2",-1,7,0);
	vcdp->declBus  (c+58,"hybrid G_0 io_x3",-1,7,0);
	vcdp->declBus  (c+60,"hybrid G_0 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_0 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid G_0 io_e",-1);
	vcdp->declBus  (c+6,"hybrid G_0 io_z",-1,7,0);
	vcdp->declBus  (c+26,"hybrid G_0 tbl_0",-1,7,0);
	// Tracing: hybrid G_0 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+27,"hybrid G_0 tbl_1",-1,7,0);
	// Tracing: hybrid G_0 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+6,"hybrid G_0 tbl_2",-1,7,0);
	// Tracing: hybrid G_0 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+28,"hybrid G_0 tbl_3",-1,7,0);
	// Tracing: hybrid G_0 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+29,"hybrid G_0 tbl_4",-1,7,0);
	// Tracing: hybrid G_0 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid G_0 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid G_0 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid G_0 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid G_0 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid G_0 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid G_0 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid G_0 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid G_0 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid G_0 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid G_0 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid G_0 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid G_0 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid G_0 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid G_0 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid G_0 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid G_0 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid G_0 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid G_0 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid G_0 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid G_0 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid G_0 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid G_0 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid G_0 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid G_0 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid G_0 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid G_0 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid G_0 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid G_0 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid G_0 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid G_0 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid G_0 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid G_0 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid G_0 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid G_0 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid G_0 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid G_0 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid G_0 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid G_0 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid G_0 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid G_0 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid G_0 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid G_0 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid G_0 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid G_0 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid G_0 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid G_0 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid G_0 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid G_0 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid G_0 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid G_0 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid G_0 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid G_0 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid G_0 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid G_0 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid G_0 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid G_0 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid G_0 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid G_0 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid G_0 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid G_0 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid G_0 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid G_0 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid G_0 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid G_0 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid G_0 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid G_0 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid G_0 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid G_0 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid G_0 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid G_0 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid G_0 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid G_0 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid G_0 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid G_0 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid G_0 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid G_0 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid G_0 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid G_0 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid G_0 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid G_0 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid G_0 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid G_0 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid G_0 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid G_0 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid G_0 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid G_0 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid G_0 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid G_0 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid G_0 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid G_0 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid G_0 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid G_0 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid G_0 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid G_0 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid G_0 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid G_0 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid G_0 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid G_0 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid G_0 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid G_0 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid G_0 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid G_0 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid G_0 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid G_0 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid G_0 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid G_0 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid G_0 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid G_0 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid G_0 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
	vcdp->declBit  (c+42,"hybrid G_1 clock",-1);
	vcdp->declBus  (c+53,"hybrid G_1 io_x0",-1,7,0);
	vcdp->declBus  (c+55,"hybrid G_1 io_x1",-1,7,0);
	vcdp->declBus  (c+57,"hybrid G_1 io_x2",-1,7,0);
	vcdp->declBus  (c+59,"hybrid G_1 io_x3",-1,7,0);
	vcdp->declBus  (c+61,"hybrid G_1 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid G_1 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid G_1 io_e",-1);
	vcdp->declBus  (c+7,"hybrid G_1 io_z",-1,7,0);
	vcdp->declBus  (c+30,"hybrid G_1 tbl_0",-1,7,0);
	// Tracing: hybrid G_1 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+31,"hybrid G_1 tbl_1",-1,7,0);
	// Tracing: hybrid G_1 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+7,"hybrid G_1 tbl_2",-1,7,0);
	// Tracing: hybrid G_1 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+32,"hybrid G_1 tbl_3",-1,7,0);
	// Tracing: hybrid G_1 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+33,"hybrid G_1 tbl_4",-1,7,0);
	// Tracing: hybrid G_1 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid G_1 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid G_1 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid G_1 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid G_1 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid G_1 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid G_1 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid G_1 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid G_1 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid G_1 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid G_1 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid G_1 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid G_1 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid G_1 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid G_1 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid G_1 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid G_1 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid G_1 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid G_1 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid G_1 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid G_1 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid G_1 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid G_1 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid G_1 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid G_1 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid G_1 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid G_1 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid G_1 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid G_1 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid G_1 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid G_1 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid G_1 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid G_1 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid G_1 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid G_1 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid G_1 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid G_1 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid G_1 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid G_1 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid G_1 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid G_1 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid G_1 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid G_1 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid G_1 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid G_1 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid G_1 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid G_1 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid G_1 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid G_1 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid G_1 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid G_1 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid G_1 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid G_1 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid G_1 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid G_1 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid G_1 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid G_1 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid G_1 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid G_1 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid G_1 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid G_1 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid G_1 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid G_1 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid G_1 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid G_1 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid G_1 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid G_1 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid G_1 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid G_1 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid G_1 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid G_1 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid G_1 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid G_1 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid G_1 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid G_1 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid G_1 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid G_1 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid G_1 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid G_1 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid G_1 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid G_1 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid G_1 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid G_1 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid G_1 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid G_1 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid G_1 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid G_1 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid G_1 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid G_1 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid G_1 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid G_1 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid G_1 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid G_1 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid G_1 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid G_1 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid G_1 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid G_1 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid G_1 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid G_1 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid G_1 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid G_1 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid G_1 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid G_1 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid G_1 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid G_1 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid G_1 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid G_1 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid G_1 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid G_1 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid G_1 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
	vcdp->declBit  (c+42,"hybrid B_0 clock",-1);
	vcdp->declBus  (c+63,"hybrid B_0 io_x0",-1,7,0);
	vcdp->declBus  (c+65,"hybrid B_0 io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_0 io_x2",-1,7,0);
	vcdp->declBus  (c+67,"hybrid B_0 io_x3",-1,7,0);
	vcdp->declBus  (c+69,"hybrid B_0 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_0 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid B_0 io_e",-1);
	vcdp->declBus  (c+9,"hybrid B_0 io_z",-1,7,0);
	vcdp->declBus  (c+34,"hybrid B_0 tbl_0",-1,7,0);
	// Tracing: hybrid B_0 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+35,"hybrid B_0 tbl_1",-1,7,0);
	// Tracing: hybrid B_0 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+9,"hybrid B_0 tbl_2",-1,7,0);
	// Tracing: hybrid B_0 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+36,"hybrid B_0 tbl_3",-1,7,0);
	// Tracing: hybrid B_0 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+37,"hybrid B_0 tbl_4",-1,7,0);
	// Tracing: hybrid B_0 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid B_0 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid B_0 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid B_0 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid B_0 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid B_0 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid B_0 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid B_0 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid B_0 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid B_0 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid B_0 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid B_0 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid B_0 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid B_0 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid B_0 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid B_0 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid B_0 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid B_0 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid B_0 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid B_0 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid B_0 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid B_0 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid B_0 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid B_0 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid B_0 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid B_0 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid B_0 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid B_0 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid B_0 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid B_0 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid B_0 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid B_0 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid B_0 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid B_0 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid B_0 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid B_0 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid B_0 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid B_0 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid B_0 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid B_0 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid B_0 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid B_0 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid B_0 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid B_0 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid B_0 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid B_0 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid B_0 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid B_0 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid B_0 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid B_0 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid B_0 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid B_0 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid B_0 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid B_0 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid B_0 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid B_0 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid B_0 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid B_0 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid B_0 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid B_0 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid B_0 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid B_0 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid B_0 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid B_0 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid B_0 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid B_0 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid B_0 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid B_0 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid B_0 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid B_0 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid B_0 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid B_0 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid B_0 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid B_0 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid B_0 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid B_0 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid B_0 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid B_0 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid B_0 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid B_0 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid B_0 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid B_0 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid B_0 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid B_0 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid B_0 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid B_0 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid B_0 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid B_0 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid B_0 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid B_0 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid B_0 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid B_0 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid B_0 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid B_0 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid B_0 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid B_0 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid B_0 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid B_0 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid B_0 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid B_0 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid B_0 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid B_0 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid B_0 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid B_0 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid B_0 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid B_0 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid B_0 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid B_0 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid B_0 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid B_0 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
	vcdp->declBit  (c+42,"hybrid B_1 clock",-1);
	vcdp->declBus  (c+62,"hybrid B_1 io_x0",-1,7,0);
	vcdp->declBus  (c+64,"hybrid B_1 io_x1",-1,7,0);
	vcdp->declBus  (c+66,"hybrid B_1 io_x2",-1,7,0);
	vcdp->declBus  (c+68,"hybrid B_1 io_x3",-1,7,0);
	vcdp->declBus  (c+70,"hybrid B_1 io_x4",-1,7,0);
	vcdp->declBus  (c+1,"hybrid B_1 io_cnt",-1,4,0);
	vcdp->declBit  (c+71,"hybrid B_1 io_e",-1);
	vcdp->declBus  (c+10,"hybrid B_1 io_z",-1,7,0);
	vcdp->declBus  (c+38,"hybrid B_1 tbl_0",-1,7,0);
	// Tracing: hybrid B_1 _RAND_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:26
	vcdp->declBus  (c+39,"hybrid B_1 tbl_1",-1,7,0);
	// Tracing: hybrid B_1 _RAND_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:28
	vcdp->declBus  (c+10,"hybrid B_1 tbl_2",-1,7,0);
	// Tracing: hybrid B_1 _RAND_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:30
	vcdp->declBus  (c+40,"hybrid B_1 tbl_3",-1,7,0);
	// Tracing: hybrid B_1 _RAND_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:32
	vcdp->declBus  (c+41,"hybrid B_1 tbl_4",-1,7,0);
	// Tracing: hybrid B_1 _RAND_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:34
	// Tracing: hybrid B_1 _GEN_0 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:35
	// Tracing: hybrid B_1 _GEN_1 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:36
	// Tracing: hybrid B_1 _GEN_2 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:37
	// Tracing: hybrid B_1 _GEN_3 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:38
	// Tracing: hybrid B_1 _GEN_4 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:39
	// Tracing: hybrid B_1 _T_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:40
	// Tracing: hybrid B_1 _T_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:41
	// Tracing: hybrid B_1 _GEN_5 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:42
	// Tracing: hybrid B_1 _GEN_6 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:43
	// Tracing: hybrid B_1 _GEN_7 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:44
	// Tracing: hybrid B_1 _GEN_8 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:45
	// Tracing: hybrid B_1 _T_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:46
	// Tracing: hybrid B_1 _T_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:47
	// Tracing: hybrid B_1 _GEN_9 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:48
	// Tracing: hybrid B_1 _GEN_10 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:49
	// Tracing: hybrid B_1 _GEN_11 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:50
	// Tracing: hybrid B_1 _GEN_12 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:51
	// Tracing: hybrid B_1 _T_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:52
	// Tracing: hybrid B_1 _T_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:53
	// Tracing: hybrid B_1 _GEN_13 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:54
	// Tracing: hybrid B_1 _GEN_14 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:55
	// Tracing: hybrid B_1 _GEN_15 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:56
	// Tracing: hybrid B_1 _GEN_16 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:57
	// Tracing: hybrid B_1 _T_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:58
	// Tracing: hybrid B_1 _T_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:59
	// Tracing: hybrid B_1 _GEN_17 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:60
	// Tracing: hybrid B_1 _GEN_18 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:61
	// Tracing: hybrid B_1 _GEN_19 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:62
	// Tracing: hybrid B_1 _GEN_20 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:63
	// Tracing: hybrid B_1 _T_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:64
	// Tracing: hybrid B_1 _GEN_21 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:65
	// Tracing: hybrid B_1 _GEN_22 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:66
	// Tracing: hybrid B_1 _GEN_23 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:67
	// Tracing: hybrid B_1 _GEN_24 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:68
	// Tracing: hybrid B_1 _T_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:69
	// Tracing: hybrid B_1 _GEN_25 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:70
	// Tracing: hybrid B_1 _GEN_26 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:71
	// Tracing: hybrid B_1 _GEN_27 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:72
	// Tracing: hybrid B_1 _GEN_28 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:73
	// Tracing: hybrid B_1 _T_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:74
	// Tracing: hybrid B_1 _GEN_29 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:75
	// Tracing: hybrid B_1 _GEN_30 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:76
	// Tracing: hybrid B_1 _GEN_31 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:77
	// Tracing: hybrid B_1 _GEN_32 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:78
	// Tracing: hybrid B_1 _T_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:79
	// Tracing: hybrid B_1 _GEN_33 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:80
	// Tracing: hybrid B_1 _GEN_34 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:81
	// Tracing: hybrid B_1 _GEN_35 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:82
	// Tracing: hybrid B_1 _GEN_36 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:83
	// Tracing: hybrid B_1 _T_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:84
	// Tracing: hybrid B_1 _GEN_37 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:85
	// Tracing: hybrid B_1 _GEN_38 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:86
	// Tracing: hybrid B_1 _GEN_39 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:87
	// Tracing: hybrid B_1 _GEN_40 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:88
	// Tracing: hybrid B_1 _T_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:89
	// Tracing: hybrid B_1 _GEN_41 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:90
	// Tracing: hybrid B_1 _GEN_42 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:91
	// Tracing: hybrid B_1 _GEN_43 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:92
	// Tracing: hybrid B_1 _GEN_44 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:93
	// Tracing: hybrid B_1 _T_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:94
	// Tracing: hybrid B_1 _GEN_45 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:95
	// Tracing: hybrid B_1 _GEN_46 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:96
	// Tracing: hybrid B_1 _GEN_47 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:97
	// Tracing: hybrid B_1 _GEN_48 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:98
	// Tracing: hybrid B_1 _T_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:99
	// Tracing: hybrid B_1 _GEN_49 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:100
	// Tracing: hybrid B_1 _GEN_50 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:101
	// Tracing: hybrid B_1 _GEN_51 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:102
	// Tracing: hybrid B_1 _GEN_52 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:103
	// Tracing: hybrid B_1 _T_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:104
	// Tracing: hybrid B_1 _GEN_53 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:105
	// Tracing: hybrid B_1 _GEN_54 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:106
	// Tracing: hybrid B_1 _GEN_55 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:107
	// Tracing: hybrid B_1 _GEN_56 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:108
	// Tracing: hybrid B_1 _T_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:109
	// Tracing: hybrid B_1 _GEN_57 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:110
	// Tracing: hybrid B_1 _GEN_58 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:111
	// Tracing: hybrid B_1 _GEN_59 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:112
	// Tracing: hybrid B_1 _GEN_60 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:113
	// Tracing: hybrid B_1 _T_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:114
	// Tracing: hybrid B_1 _GEN_61 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:115
	// Tracing: hybrid B_1 _GEN_62 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:116
	// Tracing: hybrid B_1 _GEN_63 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:117
	// Tracing: hybrid B_1 _GEN_64 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:118
	// Tracing: hybrid B_1 _T_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:119
	// Tracing: hybrid B_1 _GEN_65 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:120
	// Tracing: hybrid B_1 _GEN_66 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:121
	// Tracing: hybrid B_1 _GEN_67 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:122
	// Tracing: hybrid B_1 _GEN_68 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:123
	// Tracing: hybrid B_1 _T_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:124
	// Tracing: hybrid B_1 _GEN_69 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:125
	// Tracing: hybrid B_1 _GEN_70 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:126
	// Tracing: hybrid B_1 _GEN_71 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:127
	// Tracing: hybrid B_1 _GEN_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:128
	// Tracing: hybrid B_1 _T_72 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:129
	// Tracing: hybrid B_1 _GEN_73 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:130
	// Tracing: hybrid B_1 _GEN_74 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:131
	// Tracing: hybrid B_1 _GEN_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:132
	// Tracing: hybrid B_1 _GEN_76 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:133
	// Tracing: hybrid B_1 _T_75 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:134
	// Tracing: hybrid B_1 _GEN_77 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:135
	// Tracing: hybrid B_1 _GEN_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:136
	// Tracing: hybrid B_1 _GEN_79 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:137
	// Tracing: hybrid B_1 _GEN_80 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:138
	// Tracing: hybrid B_1 _T_78 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:139
	// Tracing: hybrid B_1 _GEN_81 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:140
	// Tracing: hybrid B_1 _GEN_82 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:141
	// Tracing: hybrid B_1 _GEN_83 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:142
	// Tracing: hybrid B_1 _GEN_84 // Ignored: Leading underscore at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:143
    }
}

void Vhybrid::traceFullThis__1(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->fullBus  (c+12,(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0),8);
	vcdp->fullBus  (c+5,(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1),8);
	vcdp->fullBus  (c+13,(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2),8);
	vcdp->fullBus  (c+14,(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0),8);
	vcdp->fullBus  (c+8,(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1),8);
	vcdp->fullBus  (c+15,(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2),8);
	vcdp->fullBus  (c+2,(vlTOPp->hybrid__DOT__cnt_1),5);
	vcdp->fullBus  (c+16,(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0),8);
	vcdp->fullBus  (c+11,(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1),8);
	vcdp->fullBus  (c+17,(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2),8);
	vcdp->fullBus  (c+18,(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_0),8);
	vcdp->fullBus  (c+19,(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_1),8);
	vcdp->fullBus  (c+3,(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2),8);
	vcdp->fullBus  (c+20,(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_3),8);
	vcdp->fullBus  (c+21,(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_4),8);
	vcdp->fullBus  (c+22,(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_0),8);
	vcdp->fullBus  (c+23,(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_1),8);
	vcdp->fullBus  (c+4,(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2),8);
	vcdp->fullBus  (c+24,(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_3),8);
	vcdp->fullBus  (c+25,(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_4),8);
	vcdp->fullBus  (c+26,(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_0),8);
	vcdp->fullBus  (c+27,(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_1),8);
	vcdp->fullBus  (c+6,(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2),8);
	vcdp->fullBus  (c+28,(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_3),8);
	vcdp->fullBus  (c+29,(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_4),8);
	vcdp->fullBus  (c+30,(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_0),8);
	vcdp->fullBus  (c+31,(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_1),8);
	vcdp->fullBus  (c+7,(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2),8);
	vcdp->fullBus  (c+32,(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_3),8);
	vcdp->fullBus  (c+33,(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_4),8);
	vcdp->fullBus  (c+34,(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_0),8);
	vcdp->fullBus  (c+35,(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_1),8);
	vcdp->fullBus  (c+9,(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2),8);
	vcdp->fullBus  (c+36,(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_3),8);
	vcdp->fullBus  (c+37,(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_4),8);
	vcdp->fullBus  (c+1,(vlTOPp->hybrid__DOT__cnt),5);
	vcdp->fullBus  (c+38,(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_0),8);
	vcdp->fullBus  (c+39,(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_1),8);
	vcdp->fullBus  (c+10,(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2),8);
	vcdp->fullBus  (c+40,(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_3),8);
	vcdp->fullBus  (c+41,(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_4),8);
	vcdp->fullBit  (c+43,(vlTOPp->reset));
	vcdp->fullBus  (c+72,(vlTOPp->io_ansR),8);
	vcdp->fullBus  (c+73,(vlTOPp->io_ansG),8);
	vcdp->fullBus  (c+74,(vlTOPp->io_ansB),8);
	vcdp->fullBus  (c+45,(vlTOPp->io_R1),8);
	vcdp->fullBus  (c+47,(vlTOPp->io_R3),8);
	vcdp->fullBus  (c+49,(vlTOPp->io_R5),8);
	vcdp->fullBus  (c+51,(vlTOPp->io_R7),8);
	vcdp->fullBus  (c+44,(vlTOPp->io_R0),8);
	vcdp->fullBus  (c+46,(vlTOPp->io_R2),8);
	vcdp->fullBus  (c+48,(vlTOPp->io_R4),8);
	vcdp->fullBus  (c+50,(vlTOPp->io_R6),8);
	vcdp->fullBus  (c+52,(vlTOPp->io_R8),8);
	vcdp->fullBus  (c+54,(vlTOPp->io_G1),8);
	vcdp->fullBus  (c+56,(vlTOPp->io_G3),8);
	vcdp->fullBus  (c+58,(vlTOPp->io_G5),8);
	vcdp->fullBus  (c+60,(vlTOPp->io_G7),8);
	vcdp->fullBus  (c+53,(vlTOPp->io_G0),8);
	vcdp->fullBus  (c+55,(vlTOPp->io_G2),8);
	vcdp->fullBus  (c+57,(vlTOPp->io_G4),8);
	vcdp->fullBus  (c+59,(vlTOPp->io_G6),8);
	vcdp->fullBus  (c+61,(vlTOPp->io_G8),8);
	vcdp->fullBus  (c+63,(vlTOPp->io_B1),8);
	vcdp->fullBus  (c+65,(vlTOPp->io_B3),8);
	vcdp->fullBus  (c+67,(vlTOPp->io_B5),8);
	vcdp->fullBus  (c+69,(vlTOPp->io_B7),8);
	vcdp->fullBit  (c+42,(vlTOPp->clock));
	vcdp->fullBus  (c+62,(vlTOPp->io_B0),8);
	vcdp->fullBus  (c+64,(vlTOPp->io_B2),8);
	vcdp->fullBus  (c+66,(vlTOPp->io_B4),8);
	vcdp->fullBus  (c+68,(vlTOPp->io_B6),8);
	vcdp->fullBus  (c+70,(vlTOPp->io_B8),8);
	vcdp->fullBit  (c+71,(vlTOPp->io_e));
    }
}
